﻿
/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use Expression source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/


#include "Q7BCompiler.h"



QString Parser::getToken(int nOffset)
{      
  if (Me.nTokenPos + nOffset < Me.tokens[Me.sFileName].size() && Me.nTokenPos + nOffset >= 0){
  //  if (nOffset >= 0){
      return Me.tokens[Me.sFileName].at(Me.nTokenPos + nOffset);  
  //  }
  }

  return "";
}

bool Parser::peekReturn(int nOffset)
{      
  QString token = getToken(nOffset);
  if (!token.isEmpty()){
    return token == "K\n";
  }
  return false;
}


bool Parser::peekIdentifier(int nOffset, QString s)
{      
  QString token = getToken(nOffset);
  if (!token.isEmpty()){
    if (token.at(0) == 'I'){
      if (s.isEmpty()){
        return true;
      }
      return token == "I" + s;
    }
  }
  return false;
}

bool Parser::peekTerm(QString s, int nOffset)
{  
  _BEGIN_

  QString token = getToken(nOffset);
  if (!token.isEmpty()){
    char c = token.at(0).toAscii();

    if (c == 'K'){
      QString sToken = token.mid(1, token.length() - 1);
      if (sToken == s){
        _END2_
        return true;
      }
    }

    _END2_
  }
  return false;
}

bool Parser::parseTerm(QString s, bool bAllowSingleColon)
{  
  parseMultiLine();

  QString token = getToken();
  if (!token.isEmpty()){
    char c = token.at(0).toAscii();

    if (c == 'K'){
      QString sToken = token.mid(1, token.length() - 1);
      if (sToken == s){
          /*if (s == "Select"){
              peekTerm(".", -1);
          }*/

        Me.nTokenPos++;
        return true;
      }
    }

  }

  return false;
}

bool Parser::parseTerm(QString *s)
{  
  parseMultiLine();

  QString token = getToken();
  if (!token.isEmpty()){
    char c = token.at(0).toAscii();


    if (c == 'K'){
      *s = token.mid(1, token.length() - 1);
      Me.nTokenPos++;
      return true;
    }
  }
  return false;
}

bool Parser::parseUntil(QString s, QString s2, QString *s3)
{  
  while(Me.nTokenPos < Me.tokens[Me.sFileName].size()){
    int n = Me.nTokenPos;
    if (parseTerm(s)){
      if (s2.isEmpty() || parseTerm(s2)){ 
        if (s == "\n"){
 // ???????         Me.nLine--;
        }
         Me.nTokenPos = n;
        return true;
      }
    } else if (s3){
      /*
     QString token = Me.tokens[Me.sFileName].at(Me.nTokenPos);  
     if (token == "#import"){ // WORKAROUND
       *s3 += "#import ";
     }
     char c = token.at(0).toAscii();
     if (c != '#'){
       if (c == '['){
         if (token.length() > 2){
          *s3 += token.mid(1, token.length() - 1);
         }
       } else {
         *s3 += token;
       }
      }*/
    }

    if (!parseReturn()){
      Me.nTokenPos++;
    }
  }
  return false;  
}

bool Parser::parseUntilNextProcecureHelper()
{  

  while(Me.nTokenPos < Me.tokens[Me.sFileName].size()){
    int n = Me.nTokenPos;

#ifdef Q7BASIC
     if (parseTerm("Sub") || parseTerm("Function") || parseTerm("Signal") || parseTerm("Event") || parseTerm("Slot")){
#elif defined OBJB
      if (parseTerm("Sub") || parseTerm("Function") || parseTerm("Action") || parseTerm("Event") || parseTerm("Delegate") || parseTerm("IBAction")){
#elif defined DROIDBASIC
      if (parseTerm("Sub") || parseTerm("Function") || parseTerm("Signal") || parseTerm("Event")){
#endif // Q7BASIC_OBJB

      Me.nTokenPos = n;
      return true;
         
    }
    if (!parseReturn()){
      Me.nTokenPos++;
    }
  }
  return false;  
}

bool Parser::parseUntilNextProcecure(QString s, QString s2)
{  
  int nSaveCurrentLine = Me.nLine;
  _BEGIN_
  if (!parseUntil(s, s2)){ 
    _END2_

    parseUntilNextProcecureHelper();
    
    Me.nLine = nSaveCurrentLine;   
    return false;
  }
  return true;  
}

bool Parser::parseString(QString *sString)
{  
  parseMultiLine();

  QString token = getToken();
  if (!token.isEmpty()){
    char c = token.at(0).toAscii();

    if (c == 'S'){
      *sString = token.mid(1, token.length() - 1);
      /*
#ifdef Q7BASIC
//      *sString = "\"" + token.mid(1, token.length() - 1) + "\"";
#elif defined OBJB
//      *sString = "@\"" + token.mid(1, token.length() - 1) + "\"";
#elif defined DROIDBASIC
#endif // Q7BASIC_OBJB
*/

      Me.nTokenPos++;
      return true;
    }
  }
  return false;
}

bool Parser::parseNumber(QString *sNumber)
{  
  parseMultiLine();

  QString token = getToken();
  if (!token.isEmpty()){
    char c = token.at(0).toAscii();

    if (c == 'N'){
      *sNumber = token.mid(1, token.length() - 1);
      Me.nTokenPos++;
      return true;
    }
  }
  return false;
}

/*
bool Parser::parseDecimal(QString *bc, QString *ad)
{  
  parseMultiLine();

  QString token = getToken();
  if (!token.isEmpty()){
    char c = token.at(0).toAscii();

    if (c == 'N'){
      / *
      *bc = token.mid(1, token.length() - 1);
      nTokenPos++;
      token = Me.tokens[Me.sFileName].at(Me.nTokenPos);  
      *ad = token.mid(1, token.length() - 1);
      nTokenPos++;
      * /
      return true;
    }
  }
  return false;
}
*/

bool Parser::parseReturn(bool bColonOnly)
{  
  if (Me.nTokenPos >= Me.tokens[Me.sFileName].size()){
    return false;
  }

  parseMultiLine();

  QString token = getToken();
  if (!token.isEmpty()){
    if (bColonOnly == false && token == "K\n"){
      Me.nTokenPos++;
      Me.nLine++;
      return true;
    }
    if (token == "K:"){
      Me.nTokenPos++;
      return true;
    }
    if (token.at(0) == 'C'){ // comment
      Me.nTokenPos++;
      //Me.nLine++;
      return true;
    }
  }
  return false;
}

bool Parser::parseComment()
{  
  if (Me.nTokenPos >= Me.tokens[Me.sFileName].size()){
    return false;
  }

  parseMultiLine();

  QString token = getToken();
  if (!token.isEmpty()){
    if (token.at(0) == 'C'){
      Me.nTokenPos++;
      return true;
    }
  }
  return false;
}

void Parser::parseMultiLine()
{

  while (Me.nTokenPos < Me.tokens[Me.sFileName].size() && Me.tokens[Me.sFileName].at(Me.nTokenPos) == "K<string>"){ 
    Me.nTokenPos++;
    Me.nLine++;
  }
  while (Me.nTokenPos < Me.tokens[Me.sFileName].size() && Me.tokens[Me.sFileName].at(Me.nTokenPos) == "K_"){ 
    Me.nTokenPos++;	
    Me.nLine++;
    parseReturn();
  }
}

bool Parser::parseIdentifier(QString *sIdentifier)
{  
  parseMultiLine();  

  QString token = getToken();
  if (!token.isEmpty()){
    char c = token.at(0).toAscii();

    if (c == 'I'){
      *sIdentifier = token.mid(1);
      
      Me.nTokenPos++;
      return true;
    }
  }
  return false;
}

bool Parser::parseIdentifier(QString sIdentifier)
{  
  parseMultiLine();

  if (sIdentifier == "MsgBox"){
    sIdentifier = sIdentifier;
  }

  QString token = getToken();
  if (!token.isEmpty()){
    char c = token.at(0).toAscii();

    if (c == 'I'){
      if (sIdentifier == token.mid(1)){
        Me.nTokenPos++;
        return true;
      }
    }
  }
  return false;
}

_array Parser::parseArrayDimReDim(bool bEmptyAllowed)
{  
  _array Array;
  
#ifdef Q7BASIC
    if (Me.bBlockArrayParsingDueToParseReDim == false && parseTerm("[")){

      bool bFirst = true;
      
      int nCount = 0;
      while (true){
        if (nCount > Q7B_MAX_ARRAYDIM){
          { error("too much dimensions for an array"); break; }
        }
        nCount++;
        
        _expressions Expression;
        if (!parseExpressionInteger(Expression)){ 
          if (bFirst && bEmptyAllowed){
            if (!parseTerm("]")){ error("] expected"); return Array; }
            for (int i = 0; i < Q7B_MAX_ARRAYDIM; i++){ //+ 1
              if (i != 0) Array.Statements << Compiler::pushCode(", ");
              Array.Statements << Compiler::pushExpression(Compiler::pushInteger(-1));    
              Array.Statement[i] = Compiler::pushInteger(-1);    
            }
            Array.bEmpty = true;

            Array.Statements = Compiler::pushExpression(Compiler::pushCode(Compiler::decode(Array.Statements)));
            return Array;
          }
          error(""); break; 
        }
        
        if (nCount > 1) Array.Statements << Compiler::pushCode(", ");
//        Array.Statements << Compiler::pushExpression(Expression.Statements);                
//        Array.Statement[Array.nCount] = Compiler::pushExpression(Expression.Statements);                
        Array.Statements << Compiler::pushExpression(Expression.Statements);                
        Array.Statement[Array.nCount] = Compiler::pushExpression(Expression.Statements);                

        Array.nCount++;

        if (!parseTerm(",")){ break; }       

        bFirst = false;

      }
      if (!parseTerm("]")){ error("] expected"); return Array; }

      for (int i = 0; i < Q7B_MAX_ARRAYDIM - Array.nCount; i++){
        Array.Statements << Compiler::pushCode(", ");
        Array.Statements << Compiler::pushExpression(Compiler::pushInteger(-1));            
        Array.Statement[Q7B_MAX_ARRAYDIM - i - 1] = Compiler::pushInteger(-1);            
      }

    //  QString sdfa = Compiler::decode(Array.Statements);
    //  sdfa = sdfa;

      Array.Statements = Compiler::pushExpression(Compiler::pushCode(Compiler::decode(Array.Statements)));
  QString sdaf = Compiler::decode(Array.Statements);
  sdaf = sdaf;

  
    }
#elif defined OBJB
#elif defined DROIDBASIC
#endif // Q7BASIC_OBJB

  return Array;
}





