﻿

/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/



#include "Q7BCompiler.h"

/*

operator int(Q7B o) 
{ 
  return 0;
}
*/

bool Parser::parseType(_expressions & ReturnExpression, _statements & VariableStatements, _array VariableArray, _array TypeArray, QString sIdentifier, QString sIdentifier2)
{

  _BEGIN_

  if (sIdentifier.isEmpty() == false || parseIdentifier(&sIdentifier)){

    QString sTypeL;
    QString sTypeR;

    if (sIdentifier.contains(".")){
      sTypeL = sIdentifier.left(sIdentifier.indexOf("."));
      sTypeR = sIdentifier.mid(sIdentifier.indexOf(".") + 1);
    } else {
      sTypeL = sIdentifier;
      sTypeR = "";
    }

    _type Type;

    if (Me.GlobalTypes.contains(sTypeL)){ // Global Type
      Type = Me.GlobalTypes[sTypeL];
    } else if (Me.Types.contains(sTypeL) && Me.Types[sTypeL].contains(sTypeR)){ // Private Type or Public Type (if it is the same class)
      Type = Me.Types[sTypeL][sTypeR];

      // wird folgendes �berhaupt gebraucht?
    } else if (Me.Types.contains(getClassName(Me.sFileName)) && Me.Types[getClassName(Me.sFileName)].contains(sTypeL)){//Me.GlobalTypes.contains(Type.Types.at(Type.Names.indexOf(sIdentifier2)))){ 
      Type = Me.Types[getClassName(Me.sFileName)][sTypeL];
    } else {
      _END_
    }

    Compiler::addReference(Type.sFileName);

    bool bParseArray = sIdentifier2.isEmpty();
    if (sIdentifier2.isEmpty() == false || (parseTerm(".") && parseIdentifier(&sIdentifier2))){
 
       if (bParseArray){
         TypeArray = parseArrayDimReDim(false);
       }


       if (!Type.Names.contains(sIdentifier2)){ error(QString("Type field name '%1' not in type '%2'").arg(sIdentifier2).arg(getClassName(Type.sFileName) + "." + Type.sName)); return false; }   

       _expressions Expression;       
       Expression.Statements << (Compiler::pushExpression(Compiler::pushInteger(Type.Names.indexOf(sIdentifier2))));

       _statements Statements;
       Statements << VariableArray.Statements;

       QString sdf = Compiler::decode(Expression.Statements);

       if (TypeArray.nCount == 0){//if (Array2.Statements.size() == 0){
         for (int i = 0; i < Q7B_MAX_ARRAYDIM; i++){      
           Expression.Statements << Compiler::pushCode(", ");
           Expression.Statements << Compiler::pushCode("Q7B_ID(-1)");
         }
       } else {
         Expression.Statements << Compiler::pushCode(", ");
         Expression.Statements << TypeArray.Statements;
       }

       Expression.Statements = Compiler::pushExpression(Compiler::pushCode(Compiler::decode(Expression.Statements)));

       if (Me.Types.contains(getClassName(Me.sFileName)) && Me.Types[getClassName(Me.sFileName)].contains(Type.Types.at(Type.Names.indexOf(sIdentifier2)))){//Me.GlobalTypes.contains(Type.Types.at(Type.Names.indexOf(sIdentifier2)))){ 
         ReturnExpression.sType = getClassName(Type.sFileName) + "." + Type.Types.at(Type.Names.indexOf(sIdentifier2));
       } else {
         ReturnExpression.sType = Type.Types.at(Type.Names.indexOf(sIdentifier2));
       }

       if (VariableArray.nCount > 0){
         _statements Tests;
         if (VariableStatements.size()){
           ReturnExpression.Statements << Compiler::push("Type Get", Compiler::push("Array At", VariableStatements, Statements), Expression.Statements);
         } else {
           ReturnExpression.Statements = Compiler::push("Type Get", Compiler::push("Array At", ReturnExpression.Statements, Statements), Expression.Statements);
         }   

         //ReturnExpression.Statements << Tests;

/*
         QString ssdfsdfdf = Compiler::decode(Tests);
         ssdfsdfdf=ssdfsdfdf;*/
/*
         QString ssdfsdfdf2 = Compiler::decode(Statements);
         ssdfsdfdf2=ssdfsdfdf2;

         QString ssdfsdfdf3 = Compiler::decode(Compiler::push("Array At", VariableStatements, Statements));
         ssdfsdfdf3=ssdfsdfdf3;*/

       } else {
         if (VariableStatements.size()){
           ReturnExpression.Statements << Compiler::push("Type Get", VariableStatements, Expression.Statements);
         } else {
           /*
         QString ssdfsdfdf2 = Compiler::decode(ReturnExpression.Statements);
         ssdfsdfdf2=ssdfsdfdf2;

         
         QString ssdfsdfdf3 = Compiler::decode(Expression.Statements);
         ssdfsdfdf3=ssdfsdfdf3;

*/
           ReturnExpression.Statements = Compiler::push("Type Get", ReturnExpression.Statements, Expression.Statements);
         }      
       }
/*
         QString ssdfsdfdf = Compiler::decode(ReturnExpression.Statements);
         ssdfsdfdf=ssdfsdfdf;
*/
        _array TypeArray2 = Type.Arrays.at(Type.Names.indexOf(sIdentifier2));

       _statements Dummy;
       _array VariableArray2;
       QString sIdentifier3;
      /* if (parseTerm(".")){
         //if (parseIdentifier(&sIdentifier3)){, sIdentifier3
         {
           if (parseType(ReturnExpression, Dummy, VariableArray2, TypeArray2, ReturnExpression.sType)){ 
             return true;
           }
      //   } else {
     //      _END_
         }
       } else {*/
         if (parseType(ReturnExpression, Dummy, VariableArray2, TypeArray2, ReturnExpression.sType)){ 
            return true;
         }
      // }
      
       return true;
    }
     
  }
  
  _END_
}

bool Parser::parseObjectIdentifier(_statements & ReturnStatements, _variableconstant & Variable)
{    
  _BEGIN_

  if (parseTerm("Global")){ // object name is also a keyword, so special parsing
    Variable.sName = "Global";
    Variable.sType = "Global";

    ReturnStatements << Compiler::pushObject(Variable.sName);
    return true;
  }

  if (Me.nLine == 30){
    Me.nLine = Me.nLine;
  }

  QString sIdentifier;
  if (parseIdentifier(&sIdentifier)){ 

    if (sIdentifier == "qApp"){ // alias for object Application
      sIdentifier = "Application";
    }

    if (Me.objects.contains(sIdentifier)){
    
      Variable.sName = sIdentifier;    
      Variable.sType = sIdentifier;

      ReturnStatements << Compiler::pushObject(Variable.sName);
      return true;

    }
#ifdef Q7BASIC
#elif defined OBJB

    if (existsAllType(sIdentifier)){
      if (parseTerm(".") && parseIdentifier("alloc") && parseTerm("(") && parseTerm(")")){

          Variable.sName = sIdentifier;
          Variable.sType = sIdentifier;

          _BEGIN2_
          if (parseTerm(".") && parseIdentifier("init") && parseTerm("(") && parseTerm(")")){

              ReturnStatements << Compiler::pushAllocInit(Variable.sName);
              return true;
          }
          _END2_

          Variable.bAlloc = true;
          ReturnStatements << Compiler::pushAlloc(Variable.sName);
          return true;
      }
    }
#elif defined DROIDBASIC
#endif // Q7BASIC_OBJB

  }

  _END_
}

bool Parser::parseProcedure_Call(_expressions & ReturnExpression, QString sClass, QString sIdentifier, QString *sType, bool bPrependSelf)
{
  _BEGIN_

  bool bbb = false;

  if (sIdentifier.isEmpty()){
    bbb = true;
  }
  if (sIdentifier.isEmpty() == false || parseIdentifier(&sIdentifier)){
    if (bbb){
      bbb = bbb;
    }

    if (Me.nLine == 395){
      Me.nLine = Me.nLine;
    }

    if (Me.nLine == 20 && Me.sFileName == "Global.QObject.q7b"){
      Me.nLine = Me.nLine;
    }

    if (sIdentifier == "MsgBox8"){
			 sIdentifier = sIdentifier;
		}

    if (parseTerm("(")){

       QList<_expressions> expressions;
       QStringList argumentNames;

       QString sArgumentName;
      _expressions Expression;

      if (peekTerm(":=", 1) == false && peekTerm(":=", 2) == false && parseExpression(Expression)){  // first do not need to be named     
        argumentNames << "";
        expressions << Expression;
        goto r;
      } else {
        if (parseIdentifier(&sArgumentName)){             
          if (!parseTerm(":=")){ 
            _END_ 
          } // error(""); return false; }     //  := expected              
          if (!parseExpression(Expression)){ error(""); return false; } 

          argumentNames << "";
          expressions << Expression;

r:          
          while (parseTerm(",")){
            Expression = _expressions();

            sArgumentName = "";
            if (peekTerm(":=", 1) == false && peekTerm(":=", 2) == false && parseExpression(Expression)){  // first do not need to be named     
              argumentNames << "";
              expressions << Expression;
              goto r;
            } else {
              if (!parseIdentifier(&sArgumentName)){ error(""); return false; }                     
              if (!parseTerm(":=")){ error(""); return false; }      // := expected     
              if (!parseExpression(Expression)){ error(""); return false; }      

              argumentNames << sArgumentName;
              expressions << Expression;
            }
          }            
        }
      }

      if (!parseTerm(")")){ error(""/*) expected*/); return false; }

      if (sIdentifier == "setRange"){
        sIdentifier = sIdentifier;
      }

      QMap<QString, _subfunction> SubsFunctions;

      bool bImplicitGlobalObject = false;
      bool bGlobalKeyword = false;
      QString sGlobalKeywordClass;

      if (!sClass.isEmpty()){

        if (sIdentifier == "insertPlainText"){
          sIdentifier = sIdentifier;
        }
        if (sIdentifier == "setText"){
          sIdentifier = sIdentifier;
        }

        bool bNotFound = true;
        QString sClassSave = sClass;

        do {
          if ((sClass.isEmpty() || !Me.DeclareClasses.contains(sClass)) && Me.Classes.contains(sClass)){
            sClass = Me.Classes[sClass];
            // ??? sClassSave = sClass;
          }
		      if (sIdentifier == "FindType"){
			     sIdentifier = sIdentifier;
		      }

          if (Me.DeclareSubsFunctions.contains(sClass) && Me.DeclareSubsFunctions[sClass].contains(sIdentifier)){
            SubsFunctions[sIdentifier] = Me.DeclareSubsFunctions[sClass][sIdentifier];

			   if (sIdentifier == "setStyleSheet"){
			     sIdentifier = sIdentifier;
		      }


            if (!Me.classes.contains(sClass) && !Me.controls.contains(sClass)){
              Compiler::addReferenceToClass(getClassName(Me.DeclareSubsFunctions[sClass][sIdentifier].sFileName)); // declare
              Compiler::addReferenceToClass(sClass); // the class actually 
            }
            bNotFound = false;
            break;

          } else {
            if (sClass.isEmpty() || !Me.DeclareClasses.contains(sClass)){
              break;
            }
            sClass = Me.DeclareClasses[sClass];
          }
        } while (true);        

        if (bNotFound){
          sClass = sClassSave;

          SubsFunctions = Me.SubsFunctions[sClass];
          if (!SubsFunctions.contains(sIdentifier)){ 
            return false;
          }
        }
        
        if (sClass == "Global"){
          _subfunction sf = SubsFunctions[sIdentifier];
          if (sf.sPublicPrivateGlobal == "Private"){ error(QString("Procedure '%1' is private in Global object and must not be used outside its class").arg(sIdentifier)); return false; }
        }
        
      } else {

        // 0. try declare subs/functions without class declared            
        if (Me.DeclareSubsFunctions[""].contains(sIdentifier)){ 
          SubsFunctions[sIdentifier] = Me.DeclareSubsFunctions[""][sIdentifier];         
        } else {

          // 1. try current class   
          SubsFunctions = Me.SubsFunctions[getClassName(Me.sFileName)]; 
          if (!SubsFunctions.contains(sIdentifier)){ 

            // 2. try Global object
            SubsFunctions = Me.SubsFunctions["Global"];         
            if (!SubsFunctions.contains(sIdentifier)){ 

              // 3. try global keyword subs/functions            
              if (!Me.GlobalSubsFunctions.contains(sIdentifier)){ 

                return false;
              } else {
                SubsFunctions[sIdentifier] = Me.GlobalSubsFunctions[sIdentifier];         
                bGlobalKeyword = true;
              }
            } else{
              bImplicitGlobalObject = true;
              _subfunction sf = SubsFunctions[sIdentifier];
              if (sf.sPublicPrivateGlobal == "Private"){ error(QString("Procedure '%1' is private in Global object and must not be used outside its class").arg(sIdentifier)); return false; }          
            }
            
          } else {
            _subfunction sf = SubsFunctions[sIdentifier];
            if (Me.SubFunction.sPublicPrivateGlobal == "Global" && sf.sPublicPrivateGlobal != "Global"){ error(QString("Procedure '%1' is part of a class and not in global space (sub or function declared with keyword 'Global'). You may directly use it with CLASSNAME.PROCEDURENAME, if it is public declared.").arg(sIdentifier)); return false; }          
          }
        }
      }

      _subfunction sf = SubsFunctions[sIdentifier];      

      if (Me.sFileName != sf.sFileName && sf.sPublicPrivateGlobal == "Private"){ error(QString("Procedure '%1' is private and must not be used outside its class").arg(sIdentifier)); return false; }
      if (sf.bCallAble == false){ error("Procedure " + sIdentifier + " must not directly called in code"); return false; }

      //int aa = sf.Arguments.size();
      //int bb = expressions.size();
      if (sf.Arguments.size() < expressions.size()){ error("too many arguments given"); return false; }
      else if (sf.Arguments.size() > expressions.size()){ error("not enough arguments given"); return false; }

      _statements Statements;

      for (int i = 0; i < expressions.size(); i++){

        _statements Statements88 = expressions.at(i).Statements;
        QString saf = Compiler::decode(Statements88);

        if (sf.bDeclare){
          QString sCast = convertDeclareType(convertDeclareType(sf.Arguments.at(i).sType), 1);

#ifdef Q7BASIC
          if(!sf.Arguments.at(i).sNamedAs.isEmpty()) Statements << Compiler::pushExpression(Compiler::pushCode(" " + sf.Arguments.at(i).sNamedAs));
          Statements << Compiler::pushExpression(Compiler::pushCode(sCast + "(" + Compiler::decode(Statements88) + ")"));
#elif defined OBJB
          if(sf.Arguments.at(i).bIsPointer){
            sCast = "&";
          }
          if(!sf.Arguments.at(i).sNamedAs.isEmpty()) Statements << Compiler::pushExpression(Compiler::pushCode(" " + sf.Arguments.at(i).sNamedAs));
          Statements << Compiler::pushExpression(Compiler::pushCode(":" + sCast + "(" + Compiler::decode(Statements88) + ")"));
#elif defined DROIDBASIC
          if(!sf.Arguments.at(i).sNamedAs.isEmpty()) Statements << Compiler::pushExpression(Compiler::pushCode(" " + sf.Arguments.at(i).sNamedAs));
          Statements << Compiler::pushExpression(Compiler::pushCode(sCast + "(" + Compiler::decode(Statements88) + ")"));
#endif // Q7BASIC_OBJB

        } else {
          Statements << Compiler::pushExpression(Statements88);        
        }
        
      }

      QString sTypeHelper;

      if (sf.bDeclare){
        for (int i = 0; i < expressions.size(); i++){
            QString asdf = sf.Arguments.at(i).sType;
            QString asddf = expressions.at(i).sType;
            QString as = sf.Arguments.at(i).sType;
            QString a88 = expressions.at(i).sType;
          if (!typeCompatible(convertDeclareType(sf.Arguments.at(i).sType), expressions.at(i).sType)){ error(QString("#%1 argument: argument type of %2 incompatible with given expression").arg(i + 1).arg(sf.Arguments.at(i).sName)); return false; }
        }

        QString saf = Compiler::decode(Statements);
 
        QString sProcedureName;

        if (sf.sDeclareAlias.isEmpty()) sProcedureName = sIdentifier;
        else sProcedureName = sf.sName;

        ReturnExpression.Statements << Compiler::push("DeclareCall", Compiler::pushIdentifier(sProcedureName), Statements);
        ReturnExpression.bDeclareUsed = true;

        sTypeHelper = convertDeclareType(sf.sType);

      } else {      
        for (int i = 0; i < expressions.size(); i++){
          if (!typeCompatible(sf.Arguments.at(i).sType, expressions.at(i).sType)){ error(QString("#%1 argument: argument type of %2 incompatible with given expression").arg(i + 1).arg(sf.Arguments.at(i).sName)); return false; }
        }

        if (bImplicitGlobalObject){
#ifdef Q7BASIC
            ReturnExpression.Statements << Compiler::pushObjectRef("Global", Compiler::pushObject("Global")) << Compiler::push("->") << Compiler::push("Call", Compiler::pushIdentifier(sIdentifier), Compiler::pushIdentifier(sGlobalKeywordClass), Compiler::pushIdentifier(ReturnExpression.bReturn ? "true" : "false"), Statements);
#elif defined OBJB
            ReturnExpression.Statements << Compiler::pushObjectRef("Global", Compiler::pushCode("[") << Compiler::pushObject("Global")) << Compiler::push("Call", Compiler::pushIdentifier(sIdentifier), Compiler::pushIdentifier(sGlobalKeywordClass), Compiler::pushIdentifier(ReturnExpression.bReturn ? "true" : "false"), Statements);
#elif defined DROIDBASIC
            ReturnExpression.Statements << Compiler::pushObjectRef("Global", Compiler::pushObject("Global")) << Compiler::push(".") << Compiler::push("Call", Compiler::pushIdentifier(sIdentifier), Compiler::pushIdentifier(sGlobalKeywordClass), Compiler::pushIdentifier(ReturnExpression.bReturn ? "true" : "false"), Statements);
#endif // Q7BASIC_OBJB
        } else if (bGlobalKeyword){
          sGlobalKeywordClass = getClassName(sf.sFileName);
#ifdef Q7BASIC
          ReturnExpression.Statements << Compiler::push("Call", Compiler::pushIdentifier(sIdentifier), Compiler::pushIdentifier(sGlobalKeywordClass), Compiler::pushIdentifier(ReturnExpression.bReturn ? "true" : "false"), Statements);
#elif defined OBJB
//          ReturnExpression.Statements << Compiler::pushCode("!$%&self") << Compiler::push("Call", Compiler::pushIdentifier(sIdentifier), Compiler::pushIdentifier(sGlobalKeywordClass), Compiler::pushIdentifier(ReturnExpression.bReturn ? "true" : "false"), Statements);
#elif defined DROIDBASIC
   //       ReturnExpression.Statements << Compiler::push("Call", Compiler::pushIdentifier(sIdentifier), Compiler::pushIdentifier(sGlobalKeywordClass), Compiler::pushIdentifier(ReturnExpression.bReturn ? "true" : "false"), Statements);
#endif // Q7BASIC_OBJB
        } else {
          QString sadf = Compiler::decode(Statements);

#ifdef Q7BASIC
          if (CONFIG["VM"] == "true"){
            if (sf.sFileName == Me.sFileName){
              ReturnExpression.Statements << Compiler::pushMe();
            }
          }
          ReturnExpression.Statements << Compiler::push("Call", Compiler::pushIdentifier(sIdentifier), Compiler::pushIdentifier(sGlobalKeywordClass), Compiler::pushIdentifier(ReturnExpression.bReturn ? "true" : "false"), Statements);
#elif defined OBJB
          if (bPrependSelf){
            ReturnExpression.Statements << Compiler::pushCode("[self") << Compiler::push("Call", Compiler::pushIdentifier(sIdentifier), Compiler::pushIdentifier(sGlobalKeywordClass), Compiler::pushIdentifier(ReturnExpression.bReturn ? "true" : "false"), Statements);
          } else {
            ReturnExpression.Statements << Compiler::push("Call", Compiler::pushIdentifier(sIdentifier), Compiler::pushIdentifier(sGlobalKeywordClass), Compiler::pushIdentifier(ReturnExpression.bReturn ? "true" : "false"), Statements);
          }
#elif defined DROIDBASIC
          ReturnExpression.Statements << Compiler::push("Call", Compiler::pushIdentifier(sIdentifier), Compiler::pushIdentifier(sGlobalKeywordClass), Compiler::pushIdentifier(ReturnExpression.bReturn ? "true" : "false"), Statements);
#endif // Q7BASIC_OBJB
        }

        sTypeHelper = sf.sType;
      }

      if (ReturnExpression.bReturn == false){
        ReturnExpression.Statements << Compiler::push(";");
      }

      ReturnExpression.sType = sTypeHelper;
      if (sType) *sType = sTypeHelper;

      Compiler::addReference(sf.sFileName);

      return true;      
   }

  }

  _END_

/*

// declare fkt?
if (bDeclare){         
 // cast auf declare native type
*/

}

bool Parser::parseQObjectPropertyOrKVC(QString *sQObjectPropertyOrKVC)
{
  if (parseTerm("!")){

    _BEGIN_

#ifdef Q7BASIC

    if (parseIdentifier(sQObjectPropertyOrKVC)){
       return true;
    }

#elif defined OBJB

    do {
      QString sKey;

      if (parseTerm("@")){
        *sQObjectPropertyOrKVC += "@";
      } else if (parseTerm(".")){
        *sQObjectPropertyOrKVC += ".";
      } else if (parseIdentifier(&sKey)){
        *sQObjectPropertyOrKVC += sKey;
      } else {
        break;
      }

    } while(true);

    return true;
#elif defined DROIDBASIC
#endif // Q7BASIC_OBJB



    _END_
  }
  return false;
}

bool Parser::parseMe(_statements & ReturnStatements)
{      
  if (parseTerm("Me")){    
    return true;
  }
  return false;
}

bool Parser::parseEnum(_expressions & Expression, QString sIdentifier, QString sIdentifier2)
{      
  _BEGIN_

  if (sIdentifier.isEmpty() == false || parseIdentifier(&sIdentifier)){   

   if (sIdentifier2.isEmpty() == false || parseTerm(".")){

      bool b = sIdentifier2.isEmpty();
      if (sIdentifier2.isEmpty() == false || parseIdentifier(&sIdentifier2)){

        QString sIdentifier3;
        if (b || parseTerm(".")){

          if (b || parseIdentifier(&sIdentifier3)){

            QString sClass;
            QString s1;
            QString s2;

            if (b){
              sClass = getClassName(Me.sFileName);
              s1 = sIdentifier;
              s2 = sIdentifier2;
            } else {
              sClass = sIdentifier;
              s1 = sIdentifier2;
              s2 = sIdentifier3;
            }

            _enumeration Enum;

            if (Me.GlobalEnums.contains(s1)){ // Global Enum
              Enum = Me.GlobalEnums[sIdentifier];     
            } else if (Me.Enums.contains(sClass) && Me.Enums[sClass].contains(s1)){ // Private Enum or Public enum (if it is the same class) -> implicit Me
              Enum = Me.Enums[sClass][s1];     
            } else if (Me.Enums.contains("Global") && Me.Enums["Global"].contains(s1)){ // enum of Global object
              Enum = Me.Enums["Global"][s1]; 
            } else {
              _END_
            }

            Compiler::addReference(Enum.sFileName);

            if (Enum.EnumNames.contains(s2)){
              if (!(Enum.sPublicPrivateGlobal == "Private" && getClassName(Me.sFileName) != sClass)){
                Expression.sType = "Integer";
                Expression.Statements << Enum.EnumValues.at(Enum.EnumNames.indexOf(s2));
                return true;      
              } else {
                { error(QString("%1 is an element of the private enum %2").arg(s2).arg(sClass + "." + s1)); return false; }
              }
            } else {
              { error(QString("%1 not an element of %2").arg(s2).arg(sClass + "." + s1)); return false; }
            }
          }
        }
      }     
    }    
  }   
  _END_
}

bool Parser::parseProperty(_statements & ReturnStatements, _variableconstant & Variable, QString sClass, bool bReturn)
{      
  // Get
  if (bReturn && Me.SubsFunctions[sClass].contains("Get_" + Variable.sName)){
    
    QString sGlobalKeywordClass;
    _expressions Expression;
    ReturnStatements << Compiler::push("Call", Compiler::pushIdentifier("Get_" + Variable.sName), Compiler::pushIdentifier(sGlobalKeywordClass), Compiler::pushIdentifier(bReturn ? "true" : "false"), Expression.Statements);
    return true;

  // Set
  } else if (!bReturn && Me.SubsFunctions[sClass].contains("Set_" + Variable.sName)){    
    if (!parseTerm("=")){ error("= missing"); return false; }     //  := expected              

    _expressions Expression;
    if (!parseExpression(Expression)){ error(""); return false; }   
    if (!typeCompatible(Variable.sType, Expression.sType)){ error("types incompatible"); return false; }

    QString sGlobalKeywordClass;
    ReturnStatements << Compiler::push("Call", Compiler::pushIdentifier("Set_" + Variable.sName), Compiler::pushIdentifier(sGlobalKeywordClass), Compiler::pushIdentifier(bReturn ? "true" : "false"), Expression.Statements);
    ReturnStatements << Compiler::push(";");
    return true;
  }

  return false;
}

bool Parser::parseVariable(_statements & ReturnStatements, _variableconstant & Variable, _statements & VariableStatements, QString sClass, bool bReturn, bool bStandaloneVariableAllowed)
{    
  _BEGIN_
bool bClassWasEmpty = sClass.isEmpty();

  if (Me.nLine == 55){
    Me.nLine = Me.nLine;
  }

  if (bStandaloneVariableAllowed && sClass.isEmpty() && parseMe(ReturnStatements)){

    if (Me.SubFunction.sPublicPrivateGlobal == "Global"){ error(QString("'Me' must not be used in global space (sub or function declared with keyword 'Global')")); return false; }          

    Variable.sName = "Me";
    Variable.sType = getClassName(Me.sFileName);

    ReturnStatements << Compiler::pushMe(/*getClassName(Me.sFileName)*/);

    return true;
  }

  if (Me.nLine == 10){
    Me.nLine = Me.nLine;
  }

  QString sIdentifier;
  if (parseIdentifier(&sIdentifier)){ 
//r:
    _array Array = parseArrayDimReDim(false);
    if (Array.nCount > 0){
      Me.bCheckArrayDimension = true;
    }

    if (sIdentifier == "d3"){
//    if (sIdentifier == "global_s"){
      sIdentifier = sIdentifier;
    }
    if (sIdentifier == "Menu"){
//    if (sIdentifier == "global_s"){
      sIdentifier = sIdentifier;
    }
    if (bStandaloneVariableAllowed && Me.isLocal()){

      if (sClass.isEmpty()){

        // arguments
        for (int i = 0; i < Me.SubFunction.Arguments.size(); i++){

          _argument Argument = Me.SubFunction.Arguments.at(i);

          if (Argument.sName == sIdentifier){
            Variable.sName = Argument.sName;
            Variable.sType = Argument.sType;
            Variable.Array = Argument.Array;
            Variable.ArrayAccess = Array;

            if (Me.bCheckArrayDimension && Variable.ArrayAccess.nCount > 0 && Variable.ArrayAccess.nCount != Variable.Array.nCount && Variable.Array.bEmpty == false/*Argument.Array.nCount != Q7B_MAX_ARRAYDIM + 1*/){ error("array dimension count not equal"); return false; }                                             
            Me.bCheckArrayDimension = false;            

            ReturnStatements << Compiler::push("Argument", Compiler::pushIdentifier(Variable.sName));
          
            Compiler::addReference(getFileNameForClass(Variable.sType));
            return true;
          }

        }

        // local vars
        QMap<int, int> possibleLocalVars;
        for (int i = 0; i < Me.SubFunction.VariablesConstants.size(); i++){

          _variableconstant vc = Me.SubFunction.VariablesConstants.at(i);

          if (vc.sName == sIdentifier && vc.nBlock <= Me.nBlock){
             possibleLocalVars[vc.nBlock] = i;
          }
        }

        // get the correct local of the innerst (highest) code block
        QMapIterator<int, int> ii(possibleLocalVars);
        ii.toBack();
        while (ii.hasPrevious()){
            ii.previous();

            //int mm = ii.key();

            int i = ii.value();

            _variableconstant vc = Me.SubFunction.VariablesConstants.at(i);

            if (vc.sName == sIdentifier){

              Variable = vc;
              Variable.ArrayAccess = Array;

              if (Me.bCheckArrayDimension && Variable.ArrayAccess.nCount > 0 && Variable.ArrayAccess.nCount != Variable.Array.nCount && Variable.Array.bEmpty == false/*Argument.Array.nCount != Q7B_MAX_ARRAYDIM + 1*/){ error("array dimension count not equal"); return false; }                                             
              Me.bCheckArrayDimension = false;                                        

              ReturnStatements << Compiler::push("Local Variable", Compiler::pushIdentifier(Variable.sName), Compiler::pushBoolean(bReturn));

              QString saf = Compiler::decode(ReturnStatements);

              Compiler::addReference(getFileNameForClass(Variable.sType));
              return true;
            }
        }
/*
        // exit function var
        if (!peekTerm("(") && !peekTerm(".") && Me.SubFunction.sSubFunctionIBActionActionSignalEventDelegateSlot == "Function"){
          if (sIdentifier == Me.SubFunction.ExitFunctionVariable.sName){

            Me.SubFunction.bExitFunctionUsed = true;

            Variable.sName = Me.SubFunction.ExitFunctionVariable.sName;
            Variable.sType = Me.SubFunction.ExitFunctionVariable.sType;
            Variable.Array = Me.SubFunction.ExitFunctionVariable.Array;
            Variable.ArrayAccess = Me.SubFunction.ExitFunctionVariable.Array;

            if (Me.bCheckArrayDimension && Variable.ArrayAccess.nCount > 0 && Variable.ArrayAccess.nCount != Variable.Array.nCount && Variable.Array.bEmpty == false){ error("array dimension count not equal"); return false; }
            Me.bCheckArrayDimension = false;            

            ReturnStatements << Compiler::push("ExitFunctionVariable");

            Compiler::addReference(getFileNameForClass(Variable.sType));
            return true;
          }

        }*/

      }    
    }
    if (bStandaloneVariableAllowed && sClass.isEmpty()){

        if (/*!Me.classes.contains(sIdentifier) && */Me.DeclareClasses.contains(sIdentifier) && peekTerm(".")){ // peekTerm(".") is needed for a working autoInit
          Variable = _variableconstant();
          Variable.sType = sIdentifier;
#ifdef Q7BASIC
          ReturnStatements << Compiler::pushCode(sIdentifier + "::");
#elif defined OBJB
          ReturnStatements << Compiler::pushCode("" + sIdentifier);
#elif defined DROIDBASIC
          ReturnStatements << Compiler::pushCode("" + sIdentifier);
#endif // Q7BASIC_OBJB

          Compiler::addReferenceToClass(getClassName(Me.DeclareClassesFileName[sIdentifier])); // declare
          return true;
        }

      if (Me.DeclareConstValues.contains(sIdentifier)){
        Variable = _variableconstant();
        Variable.sType = Me.DeclareConstTypes[sIdentifier];

        QString sCast;
#ifdef Q7BASIC
        if (Variable.sType == "Integer") sCast = "(qint64) ";
        else if (Variable.sType == "Boolean") sCast = "(bool) ";
        else if (Variable.sType == "Float" || Variable.sType == "Single" || Variable.sType == "Double") sCast = "(qreal) ";
#elif defined OBJB
        if (Variable.sType == "Integer") sCast = "(NSInteger) ";
        else if (Variable.sType == "Boolean") sCast = "(BOOL) ";
        else if (Variable.sType == "Float" || Variable.sType == "Single" || Variable.sType == "Double") sCast = "(double) ";
#elif defined DROIDBASIC
        if (Variable.sType == "Integer") sCast = "(int) ";
        else if (Variable.sType == "Boolean") sCast = "(bool) ";
        else if (Variable.sType == "Float" || Variable.sType == "Single" || Variable.sType == "Double") sCast = "(double) ";
#endif // Q7BASIC_OBJB

        ReturnStatements << Compiler::pushCode(PREFIX + "ID(" + sCast + sIdentifier + ")");

        Compiler::addReference(Me.DeclareConstValues[sIdentifier]);
        return true;
      }

      if (Me.DeclareEnumConsts2.contains(sIdentifier)){
        Variable = _variableconstant();
        Variable.sType = Me.DeclareEnumTypes[Me.DeclareEnumConsts2[sIdentifier]];

        QString sCast;
#ifdef Q7BASIC
        if (Variable.sType == "Integer") sCast = "(qint64) ";
        else if (Variable.sType == "Boolean") sCast = "(bool) ";
        else if (Variable.sType == "Float" || Variable.sType == "Single" || Variable.sType == "Double") sCast = "(qreal) ";
#elif defined OBJB
        if (Variable.sType == "Integer") sCast = "(NSInteger) ";
        else if (Variable.sType == "Boolean") sCast = "(BOOL) ";
        else if (Variable.sType == "Float" || Variable.sType == "Single" || Variable.sType == "Double") sCast = "(double) ";
#elif defined DROIDBASIC
        if (Variable.sType == "Integer") sCast = "(int) ";
        else if (Variable.sType == "Boolean") sCast = "(bool) ";
        else if (Variable.sType == "Float" || Variable.sType == "Single" || Variable.sType == "Double") sCast = "(double) ";
#endif // Q7BASIC_OBJB

        ReturnStatements << Compiler::pushCode(PREFIX + "ID(" + sCast + sIdentifier + ")");

        Compiler::addReference(Me.DeclareEnums[Me.DeclareEnumConsts2[sIdentifier]]);
        return true;
      }
    }

    QString sUseClass = sClass;
    if (sUseClass.isEmpty()) sUseClass = getClassName(Me.sFileName);
    if (!sUseClass.contains(".")){

      // class variable with imlimicit Me of the current class
      if (Me.VariablesConstants[sUseClass].contains(sIdentifier)){
        _variableconstant vc = Me.VariablesConstants[sUseClass][sIdentifier];

        QString sdf = getClassName(Me.SubFunction.sFileName);
        if (vc.sPublicPrivateGlobalLocal == "Private" && getClassName(Me.SubFunction.sFileName) != getClassName(vc.sFileName)){ error(QString("Variable or constant '%1' is private and must not be used outside its class").arg(vc.sName)); return false; }

        if (Me.SubFunction.sPublicPrivateGlobal == "Global" && vc.sPublicPrivateGlobalLocal != "Global" && sClass.isEmpty()){ error(QString("Variable or constant '%1' is part of a class and not in global space (sub or function declared with keyword 'Global')").arg(vc.sName)); return false; }          
        
        Variable = vc;
        Variable.ArrayAccess = Array;

        if (Me.bCheckArrayDimension && Variable.ArrayAccess.nCount > 0 && Variable.ArrayAccess.nCount != Variable.Array.nCount && Variable.Array.bEmpty == false/*Argument.Array.nCount != Q7B_MAX_ARRAYDIM + 1*/){ error("array dimension count not equal"); return false; }                                             
        Me.bCheckArrayDimension = false;                    

        // if there is a property function for this variable, we will use it instead
        if (!sClass.isEmpty()){
          if (parseProperty(ReturnStatements, Variable, sClass, bReturn)){
            return true;
          }
        }

        Compiler::addReference(getFileNameForClass(sUseClass));
        
        if (CONFIG["VM"] == "true"){ 
          if (sClass.isEmpty()){
            ReturnStatements << Compiler::pushMe();
          }
        }

        ReturnStatements << Compiler::push("Class Variable", Compiler::pushIdentifier(Variable.sName));
        return true;
      }

      // class variable from global class
      if (bStandaloneVariableAllowed && Me.VariablesConstants["Global"].contains(sIdentifier)){
        _variableconstant vc = Me.VariablesConstants["Global"][sIdentifier];

        if (vc.sPublicPrivateGlobalLocal == "Private"){ error(QString("Variable or constant '%1' is private in global object and must not be used outside its class").arg(vc.sName)); return false; }

        Variable = vc;
        Variable.ArrayAccess = Array;

        if (Me.bCheckArrayDimension && Variable.ArrayAccess.nCount > 0 && Variable.ArrayAccess.nCount != Variable.Array.nCount && Variable.Array.bEmpty == false/*Argument.Array.nCount != Q7B_MAX_ARRAYDIM + 1*/){ error("array dimension count not equal"); return false; }                                             
        Me.bCheckArrayDimension = false;                    

        // if there is a property function for this variable, we will use it instead
        if (!sClass.isEmpty()){
          if (parseProperty(ReturnStatements, Variable, sClass, bReturn)){
            return true;
          }
        }

        Compiler::addReference(getFileNameForClass("Global"));        

        ReturnStatements << Compiler::pushObjectRef("Global", Compiler::pushObject("Global")) << Compiler::push("->") << Compiler::push("Class Variable", Compiler::pushIdentifier(Variable.sName));        
        return true;
      }

      // Singleton object
      if (sClass.isEmpty()){
 //       QString dsf = ((QStringList)Me.Classes.keys()).join(" ");
        if (Me.Classes.contains(sIdentifier) /*&& peekTerm("(", 1) && peekTerm(")", 2)*/){ // TODO2 hier kann es zur Kollision kommen, wenn class name = function name (global oder me)

          Variable.sName = "";
          Variable.sType = sIdentifier;

          Compiler::addReference(getFileNameForClass(sIdentifier));

          ReturnStatements << Compiler::push("Class Singleton", Compiler::pushIdentifier(sIdentifier));        
          return true;
        }
      }
    }

    _expressions Expression;
    if (!sClass.isEmpty() && parseEnum(Expression, sClass, sIdentifier)){
      Variable.sName = "Enum";
      Variable.sType = Expression.sType;

      ReturnStatements << Expression.Statements;
     
      return true;
    }

    if (/*!sClass.isEmpty() && */parseType(Expression, VariableStatements, Variable.ArrayAccess, Array, sClass, sIdentifier)){
      Variable.sName = "Type";
      Variable.sType = Expression.sType;

      ReturnStatements << Expression.Statements;
      return true;
    }

    // global space
    if (bStandaloneVariableAllowed && sClass.isEmpty()){
      if (Me.GlobalVariablesConstants.contains(sIdentifier)){
        _variableconstant vc = Me.GlobalVariablesConstants[sIdentifier];

        Variable = vc;
        Variable.ArrayAccess = Array;

        if (Me.bCheckArrayDimension && Variable.ArrayAccess.nCount > 0 && Variable.ArrayAccess.nCount != Variable.Array.nCount && Variable.Array.bEmpty == false/*Argument.Array.nCount != Q7B_MAX_ARRAYDIM + 1*/){ error("array dimension count not equal"); return false; }                                             
        Me.bCheckArrayDimension = false;            

        // if there is a property function for this variable, we will use it instead
        if (!sClass.isEmpty()){
          if (parseProperty(ReturnStatements, Variable, sClass, bReturn)){
            return true;
          }
        }

        Compiler::addReference(Variable.sFileName);

        ReturnStatements << Compiler::push("Global Variable", Compiler::pushIdentifier(Variable.sName), Compiler::pushIdentifier(getClassName(vc.sFileName)));        
        return true;
      }   
    }

    if (bStandaloneVariableAllowed && Me.isLocal()){

      if (bClassWasEmpty){
        // exit function var
        if (!peekTerm("(") && !peekTerm(".")/* && Me.SubFunction.sSubFunctionIBActionActionSignalEventDelegateSlot != "Function"*/){
          if (sIdentifier == Me.SubFunction.ExitFunctionVariable.sName){

            Me.SubFunction.bExitFunctionUsed = true;

            Variable.sName = Me.SubFunction.ExitFunctionVariable.sName;
            Variable.sType = Me.SubFunction.ExitFunctionVariable.sType;
            Variable.Array = Me.SubFunction.ExitFunctionVariable.Array;
            Variable.ArrayAccess = Me.SubFunction.ExitFunctionVariable.Array;

            if (Me.bCheckArrayDimension && Variable.ArrayAccess.nCount > 0 && Variable.ArrayAccess.nCount != Variable.Array.nCount && Variable.Array.bEmpty == false/*Argument.Array.nCount != Q7B_MAX_ARRAYDIM + 1*/){ error("array dimension count not equal"); return false; }
            Me.bCheckArrayDimension = false;

            ReturnStatements << Compiler::push("ExitFunctionVariable");

            Compiler::addReference(getFileNameForClass(Variable.sType));
            return true;
          }
        }
      }
    }

  }

  _END_  
}

QStringList Parser::SubFunction(QString s) // create a QStringList from a given argument string for the builtins
{
  QStringList l;

  if (s.isEmpty()) return l;
  
  if (s.startsWith("{")){
    s = s;
  }
  if (s.contains("=")){
    s = s;
  }

  QStringList ll = s.split(",");
  for (int i = 0; i < ll.size(); i++){
    QString k = ll.at(i).trimmed();
    l << k;   
  }
  
  return l;
}

QString getArgumentName(QString s)
{
  int n = s.indexOf(" As ");
  if (n >= 0) return s.left(n).trimmed();

  return s;
}

QString getArgumentType(QString s)
{
  int n = s.indexOf(" As ");
  if (n >= 0) s = s.mid(n + 4).trimmed();
  n = s.indexOf(" = ");
  if (n >= 0) return s.left(n).trimmed();
  n = s.indexOf("[");
  if (n >= 0){
    s = s.left(n).trimmed();
  }
  n = s.indexOf("]");
  if (n >= 0){
    s = s.left(n).trimmed();
  }

  if (s.contains("::")) return "Integer";
  if (s.contains(".")) return "Integer";

  return s;
}

QString getArgumentDefaultValue(QString s)
{
  QString q;
  int n = s.indexOf(" As ");
  if (n >= 0) s = s.mid(n + 4).trimmed();
  n = s.indexOf(" = ");
  if (n >= 0) q = s.mid(n + 3).trimmed();

#ifdef Q7BASIC
  if (q == "True") q = "true";
  else if (q == "False") q = "false";
  else if (q == "Me") q = "this";
#elif defined OBJB
  if (q == "Yes") q = "YES";
  else if (q == "No") q = "NO";
  else if (q == "True") q = "YES";
  else if (q == "False") q = "NO";
  else if (q == "Me") q = "self";
#elif defined DROIDBASIC
  if (q == "True") q = "true";
  else if (q == "False") q = "false";
  else if (q == "Me") q = "this";
#endif // Q7BASIC_OBJB


  else if (q == "Dir.NoFilter") q = "QDir::NoFilter";
  else if (q == "Dir.NoSort") q = "QDir::NoSort";  
  else if (q == "InputDialog.Normal") q = "QLineEdit::Normal";  
  else if (q == "MessageBox.NoButton") q = "QMessageBox::NoButton";  
  else if (q == "MessageBox.Ok") q = "QMessageBox::Ok";  
  else if (q == "Database.LocalHost") q = "\"localhost\"";  
  else if (q == "Database.DefaultOptions") q = "\"\"";  
  else if (q == "Database.DefaultPort") q = "\"\"";  
  else if (q == "QTableWidget.MatchExactly") q = "Qt::MatchExactly";  

  if (!q.isEmpty()){
    if (q.contains(".")){
        bool ok = false;
        q.toDouble(&ok);
        if (ok) return PREFIX + "ID((double) " + q + ")";
    }
    bool ok = false;
    q.toInt(&ok);
#ifdef Q7BASIC
    if (ok) return PREFIX + "ID((qint64) " + q + ")";
#elif defined OBJB
    if (ok) return PREFIX + "ID((NSInteger) " + q + ")";
#elif defined DROIDBASIC
    if (ok) return PREFIX + "ID((long) " + q + ")";
#endif // Q7BASIC_OBJB

    return PREFIX + "ID(" + q + ")";
  }
  return "";
}

_statements getArgumentOptionalValue(QString s)
{
  if (s == "Integer") return Compiler::pushInteger(0);
  if (s == "Float") return Compiler::pushFloat(0.0);
  if (s == "Boolean") return Compiler::pushBoolean(false);
  if (s == "String") return Compiler::pushString("");
  return Compiler::pushNull();
}

bool Parser::parseBuiltin_Procedure(QString sIdentifier, QStringList & Arguments, _expressions & ReturnExpression)
{    
  _BEGIN_

  ReturnExpression.sType = Arguments.at(0);

  if (Me.nLine == 31){
    Me.nLine = Me.nLine;
  }

  //int n = Arguments.size();
  if (Arguments.size() == 1){
    if (parseTerm("(")){ 
      if (!parseTerm(")")){ _END_ } // could be a function overloading   
    }
    
    return true;
  }


#ifdef Q7BASIC
#elif defined OBJB

    if (sIdentifier == "BeginSheet" || sIdentifier == "BeginAlertSheet"){ // add extra argument automatically
        ReturnExpression.Statements << Compiler::pushExpression(Compiler::pushMe());
    }
#elif defined DROIDBASIC
#endif // Q7BASIC_OBJB

  if (!parseTerm("(")){ /*error("( expected");*/ _END_ } // could be a built-in object

  bool bDefaultValues = false;

  for (int i = 0; i < Arguments.size() - 1; i++){

    QString sArgument = Arguments.at(i + 1);

    bool bOptional = sArgument.endsWith("[") || sArgument.endsWith("]");

    _expressions Expression;

    if (i != 0){
      if (bDefaultValues || !parseTerm(",")){ 
        if (bOptional || Arguments.at(i + 1).contains("=")){
          bDefaultValues = true;

          if (bOptional){
            ReturnExpression.Statements << Compiler::pushExpression(getArgumentOptionalValue(getArgumentType(Arguments.at(i + 1))));            
          } else {
            ReturnExpression.Statements << Compiler::pushExpression(Compiler::pushCode(getArgumentDefaultValue(Arguments.at(i + 1))));            
          }
          
          continue;
        } else {
           _END_  // could be a function overloading
        }
      }
    }

 /*
      if (peekTerm(":=", 1) == false && peekTerm(":=", 2) == false && parseExpression(Expression)){  // first do not need to be named     
        argumentNames << "";
        expressions << Expression;
        goto r;
      } else {
        if (parseIdentifier(&sArgumentName)){             
          if (!parseTerm(":=")){ 
            _END_ 
          } // error(""); return false; }     //  := expected              
          if (!parseExpression(Expression)){ error(""); return false; } 

          argumentNames << "";
          expressions << Expression;

r:          
          while (parseTerm(",")){
            Expression = _expressions();

            sArgumentName = "";
            if (peekTerm(":=", 1) == false && peekTerm(":=", 2) == false && parseExpression(Expression)){  // first do not need to be named     
              argumentNames << "";
              expressions << Expression;
              goto r;
            } else {
              if (!parseIdentifier(&sArgumentName)){ error(""); return false; }                     
              if (!parseTerm(":=")){ error(""); return false; }      // := expected     
              if (!parseExpression(Expression)){ error(""); return false; }      

              argumentNames << sArgumentName;
              expressions << Expression;
            }
          }            
        }
      }
*/




//    if (!parseExpression(Expression)){ 
    bool b = false;
    if (peekTerm(":=", 1) == false && peekTerm(":=", 2) == false && parseExpression(Expression)){  // first do not need to be named     
      b = true;
    }

    if (b == false){
      QString sDummy;
      if (parseIdentifier(&sDummy)){             
        if (!parseTerm(":=")){ 
          _END_ 
        } 
        if (parseExpression(Expression)){ 
          b = true;
        } 
      }
    }

    if (b == false){

      if (i == 0 && (bOptional || bDefaultValues || Arguments.at(i + 1).contains("="))){

        if (bOptional){
          ReturnExpression.Statements << Compiler::pushExpression(getArgumentOptionalValue(getArgumentType(Arguments.at(i + 1))));            
        } else {    
          ReturnExpression.Statements << Compiler::pushExpression(Compiler::pushCode(getArgumentDefaultValue(Arguments.at(i + 1))));            
        }

        continue;
      } else {
         _END_  // could be a function overloading
      }
     
    } else if (!typeCompatible(Expression.sType, getArgumentType(Arguments.at(i + 1)))){   _END_ } // could be a function overloading


    ReturnExpression.Statements << Compiler::pushExpression(Expression.Statements);

    //int sadf99 = Expression.Statements.size();
    //int sadf99 = Compiler::pushExpression(Expression.Statements).size();
    //int sadf = ReturnExpression.Statements.size();
   // QString sdf = Compiler::decode(ReturnExpression.Statements);
   // sdf = sdf;

  }

  if (!parseTerm(")")){  _END_ } // could be a function overloading
    
  return true;
}

bool Parser::parseBuiltinClassControlObject_Procedure(QString *sProcedure, _expressions & Expression, QMap<QString, QStringList> & procedures)
{
  _BEGIN_

  {
    

    int n = 1;
    QString sTest = *sProcedure;
    while (procedures.contains(sTest)){
      _expressions Expression2 = Expression;
      if (!parseBuiltin_Procedure("", procedures[sTest], Expression2)){
        sTest = *sProcedure + QString("%1").arg(++n); // allow function overloading
        continue;
      }
      *sProcedure = sTest;
      Expression = Expression2;
      Expression.sType = procedures[sTest][0];
      if (Expression.bReturn && Expression.sType.isEmpty()){ _END_ }
      goto re;
    }  
  }

  _END_
re:
  return true;
}

bool Parser::parse(QString sFileName)
{
  return parseClass(sFileName);
}

bool Parser::parseLocalConst(_statements & Statements)
{
  bool bLocal = true;
  bool bDeclare = false;
  return parseConst(Statements, bLocal, bDeclare);
}

bool Parser::parseLocalDim(_statements & Statements)
{
  bool bLocal = true;
  bool bDeclare = false;
  return parseDimOutlet(Statements, bLocal, bDeclare);
}  

bool Parser::parseConst(_statements & Statements, bool bAddLocalConstant, bool bDeclare)
{
       
 if (parseTerm("Const")){
   if (Me.SubFunction.bProperty){ error("Const with Property not allowed"); return false; }

    QString sIdentifier;

    ////if (bDeclare && bPrivate){ error("Declare Const cannot be private. It is always public."); return false; }
    if (bDeclare){

      if (!parseIdentifier(&sIdentifier)){ error("Name of const expected"); return false; }
      //sIdentifier = plainString(sIdentifier);
      if (existsAllType(sIdentifier)){ error("Constant must not be named like existing type"); return false; }

      if (isCppObjcKeyword(sIdentifier, "Name of constant")) return false;
      
      QString sConstType = DEFAULTTYPE;
      QString sConstTypeL;
      QString sConstTypeR;
      _type Type;
      if (!parseTerm("As")){ error("As expected"); return false; }
      if (!parseAllType(&sConstType, &sConstTypeL, &sConstTypeR, &Type)){ error(""); return false; }
      Compiler::addReference(getFileNameForClass(sConstType));

      if (parseTerm(";")){ /*error("; expected"); return false;*/ }

      if (!parseReturn()){ error(""); return false; }
      
      addDeclareConst(sIdentifier, sConstType);
      return true;

    } else {

      _expressions Expression; 
      if (!parseIdentifier(&sIdentifier)){ error("identifier expected"); return false; }

      QString sConstType = DEFAULTTYPE;
      QString sConstTypeL;
      QString sConstTypeR;
      _type Type;
      if (parseTerm("As")){ 
        if (!parseAllType(&sConstType, &sConstTypeL, &sConstTypeR, &Type)){ error(""); return false; }            
        Compiler::addReference(getFileNameForClass(sConstType));
      }

      if (!parseTerm("=")){ error("= expected"); return false; } 
      if (Me.nPass == 0){
        if (!parseUntil("\n")){ error(""); return false; }
      } else {
        if (!parseExpression(Expression)){ error(""); return false; }
        if (!typeCompatible(sConstType, Expression.sType)){ error("types incompatible"); return false; }
      }

      if (!Me.types.contains(sConstType)){
        { error("Const must be of an built-in type"); return false; }
      }

      if (Me.isLocal()){

        bool bConstant = true;
        _array Array;
        bool bStatic = false;
        bool bType = false;
        addLocalVariable(sIdentifier, sConstType, bConstant, Expression.Statements, Array, bStatic);   

        if (Me.nPass == 1) Statements << Compiler::push("Local Dim", Compiler::pushIdentifier(sIdentifier), Compiler::pushIdentifier(sConstType), Compiler::pushExpression(Expression.Statements), Compiler::pushExpression(Array.Statements), Compiler::pushIdentifier(bStatic ? "true" : "false"), Compiler::pushBoolean(bType));          

      } else {

        bool bConst = true;
        _array Array;
        bool bIBOutlet = false;
        bool bSet = false;
        bool bType = false;

        addVariable(sIdentifier, sConstType, Me.sPublicPrivateGlobal, bConst, bIBOutlet, Array, bSet);     

        if (Me.sPublicPrivateGlobal == "Global"){
          if (Me.nPass == 1) Statements << Compiler::push("Global Dim", Compiler::pushIdentifier(sIdentifier), Compiler::pushIdentifier(sConstType), Compiler::pushExpression(Expression.Statements), Compiler::pushExpression(Array.Statements), Compiler::pushIdentifier(getClassName(Me.sFileName)), Compiler::pushBoolean(bType));          
        } else {
          if (Me.nPass == 1) Statements << Compiler::push("Class Dim", Compiler::pushIdentifier(sIdentifier), Compiler::pushIdentifier(sConstType), Compiler::pushExpression(Expression.Statements), Compiler::pushExpression(Array.Statements), Compiler::pushBoolean(bType), Compiler::pushBoolean(bIBOutlet));
        }

        if (!parseReturn()){ error(""); return false; }

      }        
      return true;
    }
 }

 return false;

}

bool Parser::parseDimOutlet(_statements & ReturnStatement, bool bAddLocalVariable, bool bDeclare)
{

  bool bIBOutlet = false;
  bool bReDim = false;
  bool bStatic = false;


  if (Me.nLine == 19){
    Me.nLine = Me.nLine;
  }


#ifdef Q7BASIC
      if ((Me.isLocal() == false && (bIBOutlet = parseTerm("Outlet")))
        || parseTerm("Dim")
        || parseTerm("Var")
        || (Me.isLocal() == true && (bReDim = parseTerm("ReDim")))
        || (Me.isLocal() == true && (bStatic = parseTerm("Static")))){
#elif defined OBJB
  if ((Me.isLocal() == false && (bIBOutlet = parseTerm("IBOutlet")))
    || parseTerm("Dim")
    || parseTerm("Var")
    || (Me.isLocal() == true && (bStatic = parseTerm("Static")))){
#elif defined DROIDBASIC
  if ((Me.isLocal() == false && (bIBOutlet = parseTerm("Outlet")))
    || parseTerm("Dim")
    || parseTerm("Var")
    || (Me.isLocal() == true && (bStatic = parseTerm("Static")))){
#endif // Q7BASIC_OBJB
     
        if (Me.SubFunction.bProperty && !bIBOutlet){ error("Dim with Property not allowed"); return false; }
        if (Me.SubFunction.bProperty && bIBOutlet){ error("Outlet with Property not allowed"); return false; }

        if (bDeclare && bIBOutlet){
          { error("IBOutlet with Declare not allowed"); return false; }
        } else if (bDeclare && bIBOutlet){
          { error("Dim with Declare not allowed"); return false; }
        }

dimredim:
        if (bIBOutlet){
          bIBOutlet = bIBOutlet;
        }
        bool bPreserve = false;

        QString sIdentifier;     
        _statements ReDimVariableStatements;
        _variableconstant ReDimVariable;

        if (bReDim){
          bPreserve = parseTerm("Preserve");
          
          Me.bBlockArrayParsingDueToParseReDim = true;
          if (!parseVariableOrObjectIdentifierOrProcedureCall(ReDimVariableStatements, ReDimVariable, false, true)){
            { error("Variable to use for ReDim must be declared with 'Dim' or 'Var'"); return false; }              
          }
          Me.bBlockArrayParsingDueToParseReDim = false;

        } else if (bStatic){
          if (!parseTerm("Dim") && !parseTerm("Var")){ error("'Dim' or 'Var' expected"); return false; }  
        }
        
        if (bReDim == false){
          if (!parseIdentifier(&sIdentifier)){ error("identifier expected"); return false; }

          if (sIdentifier == "aQ7BFormDesigner"){
            sIdentifier = sIdentifier;
          }
          if (existsAllType(sIdentifier)){ error("Variable must not be named like existing type"); return false; }
          if (isCppObjcKeyword(sIdentifier, "Name of variable")) return false;
          Me.sVarNameForOnAction = sIdentifier;
        }      

        if (sIdentifier ==("vq")){
          sIdentifier = sIdentifier;
        }        
        _array Array = parseArrayDimReDim(!bReDim || !Me.isLocal());        

        bool bSet = false;         

        			       
        QString sType = DEFAULTTYPE;
        QString sTypeL;
        QString sTypeR;
        _type Type;

        if (sIdentifier == "t3"){
          sIdentifier = sIdentifier;
        }

        if (!bReDim && parseTerm("As")){
          if (!parseAllType(&sType, &sTypeL, &sTypeR, &Type)){ 
            if (sType == DEFAULTTYPE) error("no type given"); 
            else error(sTypeL + (sTypeR.isEmpty() ? "" : "." + sTypeR) + " not a valid type or private or you need to write CLASSNAME.TYPENAME or unknown type"); 
            return false; 
          }            
          Compiler::addReference(getFileNameForClass(sType));
        }

        _expressions Expression; 

        bool bType = false;
        
        if (sIdentifier == "dummy"){
          sIdentifier = sIdentifier;
        }

        if (Me.nPass == 0){
          if (!parseUntil("\n")){ error(""); return false; }
        } else {
          if (!bReDim && !bIBOutlet && parseTerm("=")){ 

            if (/*sIdentifier == "ll" && */Me.nLine == 216){
              sIdentifier = sIdentifier;
            }
            if (!parseExpression(Expression)){ error(""); return false; }

            if (Array.isValid()){ error("Assignment expression not allowed when [] are used"); return false; }
            if (!typeCompatible(sType, Expression.sType)){ error("types incompatible"); return false; }
          }     

          if (!bReDim && !bIBOutlet && Expression.Statements.size() == 0 && Array.isValid() == false){
            _statements Statements;
            bool bMustMatch = false;
            bool bParseBrackets = false;


            if (Me.nLine == 980){
              Me.nLine = Me.nLine;
            }

            if (sIdentifier=="dummy"){
              sIdentifier=sIdentifier;

            }
            if (!autoInitForType(Statements, sIdentifier, sType, sTypeL, sTypeR, &bType, Array, bMustMatch, &bParseBrackets)){ 
              error("internal error: autoInitForType failed"); return false; 
            }

            Expression.Statements = Statements;              
          } else if (!bReDim && !bIBOutlet && Expression.Statements.size() == 0 && Array.isValid()){
            _statements Statements;
            if (typeArrayInit(Statements, sIdentifier, Type, sType, Array)){
               Expression.Statements = Statements;                                
            }
          }
        }

        if (bStatic && (bType || Array.isValid())){ error("variables with array with a user defined type must not be static"); return false; }          
          
          
          if (bIBOutlet){
            bSet = parseTerm("Set");  
            
            if (bSet){
                if (parseIdentifier(&sType)){  // allow    Outlet NAME As TYPE Set OVERRIDTYPE  or Outlet NAME As OVERRIDTYPE Set
                }
                //if (!Me.controls.contains(sType)){ error("control type for Set is invalid"); return false; }
            }
          }
    
    {
      //sType = sType.replace("<", "").replace(">", ""); // template data type

      if (bAddLocalVariable){

        if (bStatic && bType){
          { error("Static declared local variables must not be of an user defined Type..End Type"); return false; }
        }

        if (sIdentifier == "tt2"){
          sIdentifier = sIdentifier;
        }

        if (bReDim){

//          if (Array.nCount != ReDimVariable.Array.nCount){ error("ReDim must have same count of dimension"); return false; }

          //QString sdf = Compiler::decode(ReDimVariable.Array.Statements);
          //QString sd99f = Compiler::decode(ReDimVariableStatements);

          ReturnStatement << Compiler::push("Array ReDim", ReDimVariableStatements, Compiler::pushBoolean(bPreserve), Array.Statements) << Compiler::push(";");

        } else {
          

          bool bConst = false;
          addLocalVariable(sIdentifier, sType, bConst, Expression.Statements, Array, bStatic);     

          QString sadf = Compiler::decode(Array.Statements);

          
          if (Me.nPass == 1) ReturnStatement << Compiler::push("Local Dim", Compiler::pushIdentifier(sIdentifier), Compiler::pushIdentifier(sType), Compiler::pushExpression(Expression.Statements), Compiler::pushExpression(Array.Statements), Compiler::pushIdentifier(bStatic ? "true" : "false"), Compiler::pushBoolean(bType || Array.isValid()));          
        }

      } else {

        bool bConst = false;            

        addVariable(sIdentifier, sType, Me.sPublicPrivateGlobal, bConst, bIBOutlet, Array, bSet);     
      
        if (Me.sPublicPrivateGlobal == "Global"){
          if (Me.nPass == 1) ReturnStatement << Compiler::push("Global Dim", Compiler::pushIdentifier(sIdentifier), Compiler::pushIdentifier(sType), Compiler::pushExpression(Expression.Statements), Compiler::pushExpression(Array.Statements), Compiler::pushIdentifier(getClassName(Me.sFileName)), Compiler::pushBoolean(bType || Array.isValid()));          
        } else {
          if (Me.nPass == 1) ReturnStatement << Compiler::push("Class Dim", Compiler::pushIdentifier(sIdentifier), Compiler::pushIdentifier(sType), Compiler::pushExpression(Expression.Statements), Compiler::pushExpression(Array.Statements), Compiler::pushBoolean(bType || Array.isValid()), Compiler::pushBoolean(bIBOutlet));
        }
      }
    }
    
    
    if (bReDim == false && bReDim == false && parseTerm(",")){
      goto dimredim;
    }

     if (!parseReturn()){ error(""); return false; }

      return true;
    }
               
    return false;
}

bool Parser::existsUDFType(QString sType)
{
  if (Me.GlobalTypes.contains(sType)) return true;
  if (Me.Types.contains("Global") && Me.Types["Global"].contains(sType)) return true;

  if (sType.contains(".")){
    QString l = sType.left(sType.indexOf("."));
    QString r = sType.mid(sType.indexOf(".") + 1);
    if (Me.Types.contains(l) && Me.Types[l].contains(r)) return true;
  }
  return false;
}
/*
bool Parser::Me_classes_contains(QString s)
{
  // template
  if (s == "QListQStringList") s = "QList<QStringList>";
  return Me.classes.contains(s);
}*/

bool Parser::existsAllType(QString sType, QString *sReturnType)
{
  // built-in
  if (Me.types.contains(sType)) return true;
  if (Me.classes.contains(sType)){
    return true;
  }
  if (Me.controls.contains(sType)) return true;

  // user defined
  if (Me.Classes.contains(sType)) return true;

  if (Me.nPass == 0){
    if (Me.GlobalEnums.contains(sType)) return true;
    if (Me.Enums.contains("Global") && Me.Enums["Global"].contains(sType)) return true;
    if (Me.Enums.contains(getClassName(Me.sFileName)) && Me.Enums[getClassName(Me.sFileName)].contains(sType)) return true;

    if (Me.GlobalTypes.contains(sType)) return true;
    if (Me.Types.contains("Global") && Me.Types["Global"].contains(sType)) return true;
    if (Me.Types.contains(getClassName(Me.sFileName)) && Me.Types[getClassName(Me.sFileName)].contains(sType)) return true;
  }

  // declare
  if (Me.DeclareClasses.contains(sType)) return true;  
  if (Me.DeclareEnums.contains(sType)){
    if (sReturnType && Me.DeclareEnumConsts2.contains(sType)) *sReturnType = Me.DeclareEnumConsts2[sType]; // set correct type
    else if (sReturnType && Me.DeclareEnumTypes.contains(sType)) *sReturnType = Me.DeclareEnumTypes[sType]; // set correct type

    Compiler::addReference(Me.DeclareEnums[sType]);
    return true;  
  }

  return false;
}

bool Parser::parseAllType(QString *sType, QString *sTypeL, QString *sTypeR, _type *Type, bool bLookUpOnly)
{

  bool bParse = true;

  if (bLookUpOnly == false){
    if (parseTerm("Global")){ // keyword
      *sType = "Global";
      bParse = false;
    }
  }

  if (bLookUpOnly || bParse == false || parseIdentifier(sType)){
    if (bLookUpOnly == false){
      *sTypeL = *sType;
      *sTypeR = "";
    }    
    
    if (Me.nPass == 1){

      if ((bLookUpOnly && !sTypeL->isEmpty() && !sTypeR->isEmpty()) || parseTerm(".")){
        
        if (bLookUpOnly || parseIdentifier(sTypeR)){
  
          // Public enum (or Private Enum)
          if (Me.Enums.contains(*sTypeL) && Me.Enums[*sTypeL].contains(*sTypeR)){

            _enumeration e = Me.Enums[*sTypeL][*sTypeR];
            if (getClassName(e.sFileName) != getClassName(Me.sFileName) && e.sPublicPrivateGlobal == "Private"){
              return false;
            }

            *sType = "Integer";
            return true;           
          }

          // Public type (or Private type)
          if (Me.Types.contains(*sTypeL) && Me.Types[*sTypeL].contains(*sTypeR)){

            *Type = Me.Types[*sTypeL][*sTypeR];
            if (getClassName(Type->sFileName) != getClassName(Me.sFileName) && Type->sPublicPrivateGlobal == "Private"){
              return false;
            }

            *sType = *sTypeL + "." + *sTypeR;            
            return true;           
          }		   

        }        

      } else {

        if (*sType == "type3"){
          *sType = *sType;
        }

        // pr�fen ob typ existiert und unterst�tzt

        if (existsAllType(*sType, sType)){          
          return true;
        }

        if (Me.GlobalEnums.contains(*sType)){ // Global Enum
          *sType = "Integer";
          *sTypeL = getClassName(Me.GlobalEnums[*sType].sFileName); // needed for dependency
          return true;           
        }

        if (Me.Enums.contains(getClassName(Me.sFileName)) && Me.Enums[getClassName(Me.sFileName)].contains(*sType)){ // Private Enum or Public enum (if it is the same class) -> implicit Me
          *sTypeL = getClassName(Me.sFileName);
          *sType = "Integer";
          return true;           
        }

        if (Me.Enums.contains("Global") &&Me.Enums["Global"].contains(*sType) && Me.Enums["Global"][*sType].sPublicPrivateGlobal == "Public"){ //Public enum in Global object
          *sType = "Integer";
          return true;           
        }      

        if (Me.GlobalTypes.contains(*sType)){ // Global Type
          *sTypeL = getClassName(Me.GlobalTypes[*sType].sFileName); // needed for dependency
          *Type = Me.GlobalTypes[*sType];
          return true;           
        }

        if (Me.Types.contains("Global") && Me.Types["Global"].contains(*sType) && Me.Types["Global"][*sType].sPublicPrivateGlobal == "Public"){ //Public type in Global object
          *Type = Me.Types["Global"][*sType];
          *sType = QString("Global") + "." + *sType;                   
          return true;           
        }   

        if (Me.Types.contains(getClassName(Me.sFileName)) && Me.Types[getClassName(Me.sFileName)].contains(*sType)){ // Private Type or Public type (if it is the same class) -> implicit Me
          *Type = Me.Types[getClassName(Me.sFileName)][*sType];
          *sTypeL = getClassName(Me.sFileName);
          *sType = *sTypeL + "." + *sType;          
          return true;           
        }

        return false;
      }
    }
   
    return true;
  }  

  return false;
}
