﻿
/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/



// TODO2 eigene q7b klasse erben mit properties/subs + signals + events

#include "Q7BCompiler.h"
#ifdef Q7BASIC
extern bool Q7B_Compiler_ConvertDeclareType(QString *sCast);
#elif defined OBJB
#elif defined DROIDBASIC

#endif // Q7BASIC_OBJB

QString Parser::convertDeclareType(QString sCast, int bConvertDirectionToC)
{
  if (bConvertDirectionToC == 2){

#ifdef Q7BASIC

  if (sCast == "Boolean") return "bool";
  if (sCast == "Integer") return "qint64";
  if (sCast == "Float") return "qreal";
  if (sCast == "String") return "QString";
  if (sCast == "List") return "QStringList";
//  if (sCast == "QList<QStringList>") sCast = "QListQStringList"; // template  

  return sCast + "*"; 

#elif defined OBJB
#elif defined DROIDBASIC

  return "";
#endif // Q7BASIC_OBJB

  } else if (bConvertDirectionToC == 1){

#ifdef Q7BASIC

  if (sCast == "Boolean") return PREFIX + "CBOOL";
  if (sCast == "Integer") return PREFIX + "CQINT64";
  if (sCast == "Float") return PREFIX + "CQREAL";
  if (sCast == "String") return PREFIX + "CQSTRING";
  if (sCast == "List") return PREFIX + "CQSTRINGLIST";  

  if (sCast == "QList<QStringList>") sCast = "QListQStringList"; // template  

    if (Q7B_Compiler_ConvertDeclareType(&sCast)) return PREFIX + sCast; // bekannte qt classen automatisch generieren auch in runtime
#elif defined OBJB

      if (sCast == "NSRect") return PREFIX + "CNSRECT";
      if (sCast == "NSRange") return PREFIX + "CNSRANGE";
      if (sCast == "NSSize") return PREFIX + "CNSSIZE";
      if (sCast == "NSPoint") return PREFIX + "CNSPOINT";

      if (sCast == "Boolean") return PREFIX + "CBOOL";
      if (sCast == "Integer") return PREFIX + "CNSINTEGER";
      if (sCast == "Float") return PREFIX + "CDOUBLE";
      if (sCast == "String") return PREFIX + "CNSMUTABLESTRING";

      if (sCast == "NSInteger") return PREFIX + "CNSINTEGER";
      if (sCast == "NSUInteger") return PREFIX + "CNSINTEGER";
      if (sCast == "UInt32") return PREFIX + "CNSINTEGER";
      if (sCast == "SInt32") return PREFIX + "CNSINTEGER";
      if (sCast == "ByteCount") return PREFIX + "CNSINTEGER";
      if (sCast == "ByteOffset") return PREFIX + "CNSINTEGER";
      if (sCast == "ItemCount") return PREFIX + "CNSINTEGER";
      if (sCast == "UniCharCount") return PREFIX + "CNSINTEGER";
      if (sCast == "CFTypeID") return PREFIX + "CNSINTEGER";
      if (sCast == "CFOptionFlags") return PREFIX + "CNSINTEGER";
      if (sCast == "CFHashCode") return PREFIX + "CNSINTEGER";
      if (sCast == "CFIndex") return PREFIX + "CNSINTEGER";

      if (sCast == "CGFloat") return PREFIX + "CDOUBLE";

      if (sCast == "Array") return PREFIX + "CNSMUTABLEARRAY";
      if (sCast == "Dictionary") return PREFIX + "CNSMUTABLEDICTIONARY";
      if (sCast == "NSToolbarItem") return PREFIX + "CNSTOOLBARITEM";

      if (sCast == "Rect") return PREFIX + "CNSRECT";
      if (sCast == "Range") return PREFIX + "CNSRANGE";
      if (sCast == "Size") return PREFIX + "CNSSIZE";
      if (sCast == "Point") return PREFIX + "CNSPOINT";

      if (sCast == "id") return PREFIX + "ID";

      if (existsAllType(sCast)){
          return PREFIX + "C" + sCast.toUpper();
      }

      return PREFIX + "CNSINTEGER";
#elif defined DROIDBASIC

  if (sCast == "Boolean") return PREFIX + "CBOOLEAN";
  if (sCast == "Integer") return PREFIX + "CINTEGER";
  if (sCast == "Long") return PREFIX + "CLONG";
  if (sCast == "Float") return PREFIX + "CDOUBLE";
  if (sCast == "String") return PREFIX + "CSTRING";

      if (existsAllType(sCast)){
          return PREFIX + "C" + sCast.toUpper();
      }

      return PREFIX + "CNSINTEGER";

#endif // Q7BASIC_OBJB

   // { error(QString("Could not find a matching cast function for declare type (C/C++): %1").arg(sCast)); return ""; }

  } else {

    if (Me.DeclareClasses.contains(sCast) && !Me.DeclareClasses[sCast].isEmpty()){
	    return Me.DeclareClasses[sCast];
	  }

    // remove modifiers
    if (sCast.startsWith("short ")){
      sCast = sCast.mid(QString("short ").length());
    } else if (sCast.startsWith("long ")){
      sCast = sCast.mid(QString("long ").length());
    } else if (sCast.startsWith("signed ")){
      sCast = sCast.mid(QString("signed ").length());
    } else if (sCast.startsWith("unsigned ")){
      sCast = sCast.mid(QString("unsigned ").length());
    } else if (sCast.startsWith("const ")){
      sCast = sCast.mid(QString("const ").length());
    }

    // remove & *
    sCast = sCast.remove("&");
 //   bool bPointer = sCast.contains("**");
    sCast = sCast.remove("*");

#ifdef Q7BASIC
    if (sCast == "bool"){
#elif defined OBJB
    if (sCast == "BOOL" || sCast == "bool"){
#elif defined DROIDBASIC
    if (sCast == "bool"){
#endif // Q7BASIC_OBJB
      return "Boolean";
#ifdef Q7BASIC
    } else if (sCast == "int" || sCast == "long" || sCast == "short" || sCast == "long" || sCast == "signed" || sCast == "unsigned" || sCast == "char"){
#elif defined OBJB
    } else if (sCast == "int" || sCast == "long" || sCast == "short" || sCast == "long" || sCast == "signed" || sCast == "unsigned" || sCast == "char"){
#elif defined DROIDBASIC
    } else if (sCast == "int" || sCast == "short" || sCast == "long" || sCast == "signed" || sCast == "unsigned"){
#endif // Q7BASIC_OBJB
      return "Integer";

    } else if (sCast == "float" || sCast == "double"){
      return "Float";
#ifdef Q7BASIC
    } else if (sCast == "qreal"){
        return "Float";
#elif defined OBJB

    } else if (sCast == "NSRect"){
        return "Rect";
    } else if (sCast == "NSRange"){
        return "Range";
    } else if (sCast == "NSSize"){
        return "Size";
    } else if (sCast == "NSPoint"){
        return "Point";
#elif defined DROIDBASIC
    } else if (sCast == "long"){
        return "Long";

    } else if (sCast == "char"){
        return "Char";

#endif // Q7BASIC_OBJB
    }

#ifdef Q7BASIC

    if (sCast == "QString"){
      return "String";
    } else if (sCast == "QStringList"){
      return "QStringList";

    } else if (sCast == "QListQStringList"){
      return "QList<QStringList>";
    }

    QStringList IsInteger;

    IsInteger << "qint8";
    IsInteger << "qint16";
    IsInteger << "qint32";
    IsInteger << "qint64";
    IsInteger << "qlonglong";
    IsInteger << "quint8";
    IsInteger << "quint16";
    IsInteger << "quint32";
    IsInteger << "quint64";
    IsInteger << "qulonglong";
    IsInteger << "uchar";
    IsInteger << "uint";
    IsInteger << "ulong";
    IsInteger << "ushort";

    if (IsInteger.contains(sCast)){
      return "Integer";
    } else if (sCast == "qreal"){
      return "Float";
    }

    return sCast;

#elif defined OBJB

    if (sCast == "NSString" || sCast == "NSMutableString"){
      return "String";
  //  } else if (sCast == "QStringList"){
   //   return "List";
    }

    if (sCast == "NSArray" || sCast == "NSMutableArray"){
      return "Array";
    }

    if (sCast == "NSDictionary" || sCast == "NSMutableDictionary"){
      return "Dictionary";
    }

    QStringList IsInteger;

    IsInteger << "uchar";
    IsInteger << "uint";
    IsInteger << "ulong";
    IsInteger << "ushort";
    IsInteger << "NSInteger";
    IsInteger << "NSUInteger";

    if (IsInteger.contains(sCast)){
      return "Integer";
    } else if (sCast == "double" || sCast == "single"){
      return "Float";
    }

    if (sCast == "UInt32") return "Integer";
    if (sCast == "SInt32") return "Integer";
    if (sCast == "ByteCount") return "Integer";
    if (sCast == "ByteOffset") return "Integer";
    if (sCast == "ItemCount") return "Integer";
    if (sCast == "UniCharCount") return "Integer";
    if (sCast == "CFTypeID") return "Integer";
    if (sCast == "CFOptionFlags") return "Integer";
    if (sCast == "CFHashCode") return "Integer";
    if (sCast == "CFIndex") return "Integer";

    if (sCast == "CGFloat") return "Float";
    if (sCast == "NSTimeInterval") return "Float";

    return sCast;

#elif defined DROIDBASIC
    
    if (sCast == "String"){
      return "String";
    }

    QStringList IsInteger;

    IsInteger << "byte";
    IsInteger << "short";
    IsInteger << "int";

    if (IsInteger.contains(sCast)){
      return "Integer";
    } else if (sCast == "float" || sCast == "double"){
      return "Float";
    } else if (sCast == "long"){
      return "Long";
    } else if (sCast == "char"){
      return "Char";
      return "Char";
    }

    return sCast;

#endif // Q7BASIC_OBJB
  }
  return "";

}

bool Parser::parseDeclareSubFunction(QString sSubFunctionIBActionActionSignalEventDelegateSlot, bool bStatic)
{    
  _BEGIN_  

  QString sClass;
  
  if (!parseString(&sClass)){ 
    // no error anymore       
    if (sSubFunctionIBActionActionSignalEventDelegateSlot != "Sub" && sSubFunctionIBActionActionSignalEventDelegateSlot != "Function"){ error("Name of native class expected"); return false; }
  }

  //sClass = plainString(sClass);

  QString sAlias;
  if (parseTerm("Alias")){ 
    if (!parseString(&sAlias)){ error("Alias expected"); return false; }
    //sAlias = plainString(sAlias);
  }

  if (bStatic){
    { error("Sorry. Static for declare is not supported yet"); return false; }
  }

#ifdef Q7BASIC

  QString sNative;
 
  QString sReturnType;
  if (parseTerm("*")){ sReturnType += "*"; }
  if (parseTerm("&")){ sReturnType += "&"; }
  if (parseIdentifier("const")){ sReturnType += "const "; }
  QString k;
  if (!parseIdentifier(&k)){ error("C++: argument type expected"); return false; }
  sReturnType += k;
  if (parseTerm("*")){ sReturnType += "*"; }
  if (parseTerm("&")){ sReturnType += "&"; }
  if (parseIdentifier("const")){ sReturnType += "const "; }

  sNative += sReturnType;
  sNative += " ";

  QString sSub;
  if (!parseIdentifier(&sSub)){ 
    if (!parseTerm(&sSub)){ // might be a Q7Basic keyword used
      error("C++: name expected"); return false; 
    }
  }

  if (!parseTerm("(")){ error("( expected"); return false; }

  sNative += sSub;

  Me.SubFunction.Arguments.clear();

  sNative += "(";

  if (!parseTerm(")")){ 

    bool bFirst = true;
    do {
      if (bFirst == false) sNative += ",";
      bFirst = false;

      QString s;
      if (parseTerm("&")){ s += "&"; }
      if (parseTerm("*")){ s += "*"; }
      if (parseIdentifier("const")){ 
      s += "const "; }
      QString k;
      if (!parseIdentifier(&k)){ error("C++: argument type expected"); return false; }
      s += k;
      if (parseTerm("&")){ s += "&"; }
      if (parseTerm("*")){ s += "*"; }
      if (parseIdentifier("const")){ s += "const "; }

      if (s.trimmed() == "void"){
        if (parseTerm(")")){
          goto we;
        }
      }

      _argument Argument;

      Argument.sType = s;

      sNative += s;

      if (!parseIdentifier(&s)){ error("C++: argument name expected"); return false; }

      Argument.sName = s;

      sNative += " ";
      sNative += s;

      Me.SubFunction.Arguments.append(Argument);

    } while (parseTerm(","));

    if (!parseTerm(")")){ error(""/*) expected*/); return false; }
  }
we:  
  sNative += ")";

  if (parseTerm(";")){/* error("; expected"); return false;*/ }
  
  if (!parseReturn()){ error("new line expected"); return false; }

  addDeclareSubFunction(sSubFunctionIBActionActionSignalEventDelegateSlot, sAlias, sSub, Me.sFileName, sClass, sReturnType, bStatic, sNative);  

  return true;

#elif defined OBJB

  QString sNative;

  if (parseTerm("+")){
    sNative += "+";
    bStatic = true;
  } else if (parseTerm("-")){
    sNative += "-";
    bStatic = false;
  } else { error("- expected"); return false; }

  if (!parseTerm("(")){ error("( expected"); return false; }
  QString sReturnType;
  if (!parseIdentifier(&sReturnType)){ error("ObjC: return type expected"); return false; }
  if (parseTerm("*")){ sReturnType += "*"; }
  if (!parseTerm(")")){ error(""); return false; }

  sNative += "(";
  sNative += sReturnType;
  //sNativeType = sReturnType;
  sNative += ")";





  /*
  QString sReturnType;
  if (parseTerm("*")){ sReturnType += "*"; }
  if (parseTerm("&")){ sReturnType += "&"; }
  if (parseIdentifier("const")){ sReturnType += "const "; }
  QString k;
  if (!parseIdentifier(&k)){ error("C++: argument type expected"); return false; }
  sReturnType += k;
  if (parseTerm("*")){ sReturnType += "*"; }
  if (parseTerm("&")){ sReturnType += "&"; }
  if (parseIdentifier("const")){ sReturnType += "const "; }

  sNative += sReturnType;
  */
  sNative += " ";

  QString sSub;
  if (!parseIdentifier(&sSub)){
    if (!parseTerm(&sSub)){ // might be a keyword used
      error("ObjC: name expected"); return false;
    }
  }

  //if (!parseTerm("(")){ error("( expected"); return false; }

  sNative += sSub;

  Me.SubFunction.Arguments.clear();

  QString sNamedAs;
  while (parseTerm(":")){

    if (!parseTerm("(")){ error("( expected"); return false; }
    QString s;
    if (!parseIdentifier(&s)){ error("ObjC: argument type expected"); return false; }

  //  bool bPointer2 = false;
    _argument Argument;
    Argument.bIsPointer = false;

    if (parseTerm("*")){
     // bPointer2 = !allTypes.contains(s);
     // bPointer |= bPointer2;
      //convertDeclareTypeFromObjC(s, &bPointer2);
      s += "*";
    } else if (parseTerm("**")){
      s += "**";
      Argument.bIsPointer = true;
    //  bPointer2 = true;
    //  bPointer |= bPointer2;
    }

   // LocalArgumentsPointer.append(bPointer2);

    sNative += sNamedAs;
    sNative += ":";
   /* sDeclareDelegateSignature += ":";
    if (bPointer2){
      sDeclareDelegateCall += ":(";
    } else {
      sDeclareDelegateCall += ":NSOBJECT(";
    }*/

   // LocalArgumentsType.append(s);
    if (!parseTerm(")")){ error(""/*) expected*/); return false; }

    sNative += "(";
    sNative += s;
    sNative += ") ";


    Argument.sType = s;

    if (!parseIdentifier(&s)){ error("ObjC: argument name expected"); return false; }
   // LocalArgumentsName.append(s);

  //  sDeclareDelegateSignature += s;

   // sDeclareDelegateCall += s;
   // sDeclareDelegateCall += ")";

    Argument.sName = s;
    Argument.sNamedAs = sNamedAs;
    Me.SubFunction.Arguments.append(Argument);


    sNative += s;
    sNative += " ";

    // eat named argument
  /*  if (parseIdentifier(&s)){
      sNative += s;
    }*/

    sNamedAs = "";
    if (!parseIdentifier(&sNamedAs)){ }

  }


  if (parseTerm(";")){/* error("; expected"); return false;*/ }

  if (!parseReturn()){ error("new line expected"); return false; }

  addDeclareSubFunction(sSubFunctionIBActionActionSignalEventDelegateSlot, sAlias, sSub, Me.sFileName, sClass, sReturnType, bStatic, sNative);

  return true;

#elif defined DROIDBASIC

  QString sNative;
 
  QString sReturnType;
  if (parseTerm("*")){ sReturnType += "*"; }
  if (parseTerm("&")){ sReturnType += "&"; }
  if (parseIdentifier("const")){ sReturnType += "const "; }
  QString k;
  if (!parseIdentifier(&k)){ error("C++: argument type expected"); return false; }
  sReturnType += k;
  if (parseTerm("*")){ sReturnType += "*"; }
  if (parseTerm("&")){ sReturnType += "&"; }
  if (parseIdentifier("const")){ sReturnType += "const "; }

  sNative += sReturnType;
  sNative += " ";

  QString sSub;
  if (!parseIdentifier(&sSub)){ 
    if (!parseTerm(&sSub)){ // might be a Q7Basic keyword used
      error("C++: name expected"); return false; 
    }
  }

  if (!parseTerm("(")){ error("( expected"); return false; }

  sNative += sSub;

  Me.SubFunction.Arguments.clear();

  sNative += "(";

  if (!parseTerm(")")){ 

    bool bFirst = true;
    do {
      if (bFirst == false) sNative += ",";
      bFirst = false;

      QString s;
      if (parseTerm("&")){ s += "&"; }
      if (parseTerm("*")){ s += "*"; }
      if (parseIdentifier("const")){ 
        s += "const "; }
      QString k;
      if (!parseIdentifier(&k)){ error("C++: argument type expected"); return false; }
      s += k;
      if (parseTerm("&")){ s += "&"; }
      if (parseTerm("*")){ s += "*"; }
      if (parseIdentifier("const")){ s += "const "; }

      if (s.trimmed() == "void"){
        if (parseTerm(")")){
          goto we;
        }
      }

      _argument Argument;

      Argument.sType = s;

      sNative += s;

      if (!parseIdentifier(&s)){ error("C++: argument name expected"); return false; }

      Argument.sName = s;

      sNative += " ";
      sNative += s;

      Me.SubFunction.Arguments.append(Argument);

    } while (parseTerm(","));

    if (!parseTerm(")")){ error(""/*) expected*/); return false; }
  }
we:  
  sNative += ")";

  if (parseTerm(";")){/* error("; expected"); return false;*/ }
  
  if (!parseReturn()){ error("new line expected"); return false; }

  addDeclareSubFunction(sSubFunctionIBActionActionSignalEventDelegateSlot, sAlias, sSub, Me.sFileName, sClass, sReturnType, bStatic, sNative);  

  return true;

#endif // Q7BASIC_OBJB

   return true;

  _END_  
}

void Parser::addDeclareSubFunction(QString sSubFunctionIBActionActionSignalEventDelegateSlot, QString sDeclareAlias, QString sName, QString sFileName, QString sDeclareClass, QString sType, bool bStatic, QString sDeclareNative)
{  
  bool bExists = false;

  if (sName == "showMenu"){
	  sName = sName;
  }

  if (sName == "alloc"){
      error("'" + sName + "' already declared as built-in and ready for use, e.g. NSString.alloc().init()"); return;
  }

  if (Me.nPass == 0){
    bExists = Me.GlobalSubsFunctions.contains(sDeclareAlias.isEmpty() ? sName : sDeclareAlias);

    if (bExists){
      //Me.nLine--; // WORKAROUND
      error("Procedure '" + sName + "' already declared with the same name somewhere in project"); return;
    }
  }
  
  // allow alloc
 if (sName != "alloc" && isCppObjcKeyword(sName, "Name of procedure")) return;

  _subfunction SubFunction;
  
  SubFunction.sFileName = sFileName;
  SubFunction.sPublicPrivateGlobal = "";
  SubFunction.sSubFunctionIBActionActionSignalEventDelegateSlot = sSubFunctionIBActionActionSignalEventDelegateSlot;
  SubFunction.sName = sName;
  SubFunction.sType = sType;
  SubFunction.bStatic = bStatic;
  SubFunction.Arguments = Me.SubFunction.Arguments;

  SubFunction.bDeclare = true;
  SubFunction.sDeclareAlias = sDeclareAlias;
  SubFunction.sDeclareClass = sDeclareClass;
  SubFunction.sDeclareNative = sDeclareNative;   

  SubFunction.bCallAble = 
      ! (sSubFunctionIBActionActionSignalEventDelegateSlot == "Event"
      || sSubFunctionIBActionActionSignalEventDelegateSlot == "Action"
      || sSubFunctionIBActionActionSignalEventDelegateSlot == "Delegate"
      || sSubFunctionIBActionActionSignalEventDelegateSlot == "Signal"
   );

  if (sSubFunctionIBActionActionSignalEventDelegateSlot == "Signal"){
    Me.DeclareSignals[sDeclareClass][sDeclareAlias.isEmpty() ? sName : sDeclareAlias] = SubFunction;
  } else if (sSubFunctionIBActionActionSignalEventDelegateSlot == "Event"){
    Me.DeclareEvents[sDeclareClass][sDeclareAlias.isEmpty() ? sName : sDeclareAlias] = SubFunction;
  } else if (sSubFunctionIBActionActionSignalEventDelegateSlot == "Delegate"){
    Me.DeclareDelegates[sDeclareClass][sDeclareAlias.isEmpty() ? sName : sDeclareAlias] = SubFunction;

    Me.DeclareDelegatesList[(sDeclareAlias.isEmpty() ? sName : sDeclareAlias) + QString().fill(':', SubFunction.Arguments.count())] = SubFunction;

  } else {
    Me.DeclareSubsFunctionsSignalsEventsDelegates[sDeclareClass][sDeclareAlias.isEmpty() ? sName : sDeclareAlias] = SubFunction;
  }
  Me.DeclareSubsFunctions[sDeclareClass][sDeclareAlias.isEmpty() ? sName : sDeclareAlias] = SubFunction;

  if (/*!Me.classes.contains(sDeclareClass) && */!Me.DeclareClasses.contains(sDeclareClass)){
    Me.DeclareClasses[sDeclareClass] = ""; // set declare class if no explicit declare class statement is given, might be overriden later by declare class
    Me.DeclareClassesFileName[sDeclareClass] = sFileName;
  }
  
}

void Parser::addDeclareEnum(QString sName, QString sType, QStringList EnumNames)
{
  if (Me.nPass == 0){
    Me.DeclareEnums[sName] = Me.sFileName;
    Me.DeclareEnumTypes[sName] = sType;
    Me.DeclareEnumConsts[sName] = EnumNames;

    for (int i = 0; i < EnumNames.size(); i++){
      Me.DeclareEnumConsts2[EnumNames.at(i)] = sName;
    }
  }
}

void Parser::addDeclareConst(QString sName, QString sType)
{
  if (Me.nPass == 0){
    Me.DeclareConstValues[sName] = Me.sFileName;
    Me.DeclareConstTypes[sName] = sType;    
  }
}
/*
bool Parser::parseDeclare(_expressions & Expression)
{    
  _BEGIN_

  // if (parseDeclareCall(bool bDelegate, bool bEvent, bool bSignal)
  // if (parseDeclareEnum(sCurrentFileName, sReturnStatements, sReturnType)){ return true; }
  // if (parseDeclareConstant(sCurrentFileName, sReturnStatements, sReturnType)){ return true; }


  _END_  
}*/
/*
bool Parser::parseDeclareCall(QList<QVariant> *sReturnStatements, bool bReturn, QString *sReturnType)
{
  _BEGIN_

  // if (parseDeclareStaticCall(sCurrentFileName, sReturnStatements, sReturnType)){ return true; }

  _END_  
}

bool Parser::parseDeclareStaticCall(QList<QVariant> *sReturnStatements, bool bReturn, QString *sReturnType)
{
  _BEGIN_

  // if (parseDeclareStaticCall(sCurrentFileName, sReturnStatements, sReturnType)){ return true; }

  _END_  
}*/

 // if (parseDeclareEnum(sCurrentFileName, sReturnStatements, sReturnType)){ return true; }
  
// if (parseDeclareConstant(sCurrentFileName, sReturnStatements, sReturnType)){ return true; }

/*
  if (parseIdentifierWithoutEscape(&sIdentifier)){
    if (DeclareEnumValues.contains(sIdentifier)){
//    if (DeclareEnumValues[sCurrentFileName].contains(sIdentifier)){
      {  *sReturnStatements += sIdentifier; return true; }
    }
    if (DeclareConst.contains(sIdentifier)){
      {  *sReturnStatements += sIdentifier; return true; }

    }

*/

