﻿

/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/


#include "Q7BCompiler.h"

//addHierarchy("QMenuBar", "QWidget", "QObject");
//addHierarchy("QPushButton", "QAbstractButton", "QWidget", "QObject");

void Parser::addHierarchy(QString sClass, QString sSuperClass)
{
  if (sClass == "Class") return;
  if (sClass == "Dictionary") return;
  if (sClass == "List") return;
  if (sClass == "Module") return;  
  if (sClass == "uiClass") return;  
  if (sClass == "FormClass") return;  

//  Me.super_classes[sClass] = sSuperClass;


  //if (sSuperClass.isEmpty()) return;
/*
  if (sClass == DEFAULTCLASS){
    Me.sub_classes[sClass] << "";
    return;
  }*/
/*
  if (Me.sub_classes.contains(sSuperClass)){
    QString sNewSuperClass;

    if (Me.super_classes.contains(sSuperClass)){      
      sNewSuperClass = Me.super_classes[sSuperClass];
      if (sNewSuperClass == sClass){
        Me.sub_classes[sSuperClass] << sClass;
        return;
      }
    } else {
      sNewSuperClass = sSuperClass;
    }

    addHierarchy(sClass, sNewSuperClass);

  } else {
    Me.sub_classes[sSuperClass] << sClass;
  }*/
}

QString Parser::plainCType(QString sCast)
{
  sCast = sCast.replace("*", "");
  sCast = sCast.replace("&", "");
  return sCast;
}

bool Parser::StringInit(QString l, QString r)
{
  // at runtime created from string possible
  if (l == "String" || r == "String"){
    if (l == "NSData" || r == "NSData") return true;
    if (l == "NSImage" || r == "NSImage") return true;
    if (l == "NSMenu" || r == "NSMenu") return true;
    if (l == "NSMenuItem" || r == "NSMenuItem") return true;
  }
  return false;
}

QString Parser::convertType(QString s)
{
#ifdef Q7BASIC
  if (s == "Byte" || s == "Short" || s == "Int8" || s == "Int16" || s == "Int32" || s == "Int64")
    return "Integer";

  if (s == "Single" || s == "Double")
    return "Float";

  if (s == "CString")
    return "String";

  if (s == "Object")
    return "id";

  if (s.contains(".")) return "Integer";  // indicates a Qt binding constant

#elif defined OBJB

  if (s == "Byte" || s == "Short" || s == "Int8" || s == "Int16" || s == "Int32" || s == "Int64" || s == "Long")
    return "Integer";
  if (s == "Single" || s == "Double")
    return "Float";
  if (s == "Data") return "NSMutableData";
  if (s == "Array") return "NSMutableArray";
  if (s == "Dictionary") return "NSMutableDictionary";
  if (s == "NSObject") return "id"; // hope it can be mixed

  // declare types:
/*
  if (s == "NSString*") return "NSString";
  if (s == "NSData*") return "NSData";
  if (s == "NSDictionary*") return "NSDictionary";
  if (s == "NSArray*") return "NSArray";
  if (s == "BOOL") return "Boolean";
  if (s == "BOOLEAN") return "Boolean";
  if (s == "INTEGER") return "Integer";
  if (s == "LONG") return "Integer";
  if (s == "SINGLE") return "Float";
  if (s == "DOUBLE") return "Float";
  if (s == "POINT") return "NSPoint";
  if (s == "SIZE") return "NSSize";
  if (s == "RECT") return "NSRect";
  if (s == "RANGE") return "NSRange";
  if (s == "NSOBJECT") return "id";
  if (s == "NSOBJECT") return "id";
*/
#elif defined DROIDBASIC
  if (s == "Byte" || s == "Short")
    return "Integer";

  if (s == "Single" || s == "Double")
    return "Float";

  if (s == "Object")
    return "id";

#endif // Q7BASIC_OBJB
    return s;
}


bool Parser::checkClassHierarchy(QString l, QString r)
{
  if (Me.Classes.contains(l) && Me.Classes.contains(r)){
    return true; // both are user defined classes which inherits QObject
  }    

  if (Me.Classes.contains(l)){
    l = Me.Classes[l]; // try super class
  }          

  if (Me.Classes.contains(r)){
    r = Me.Classes[r]; // try super class
  }    
  if (l == r) return true;

  if (l == "NSView"){
      l = l;
  }
  if (Me.super_classes.contains(l)){
    QStringList h = Me.super_classes[l];
    QString asfd = h.join(";");
    if (h.contains(r)){
      return true;
    }
  }

  if (Me.super_classes.contains(r)){
    QStringList h = Me.super_classes[r];
   // QString asfd = h.join(";");
    if (h.contains(l)){
      return true;
    }
  }
  return false;
}

bool Parser::typeCompatible(QString l, QString r, QString o)
{
#ifdef Q7BASIC
#elif defined OBJB
    if (r == "alloc") return true; // WORKAROUND for alloc
#elif defined DROIDBASIC
#endif // Q7BASIC_OBJB


  l = convertDeclareType(l);
  r = convertDeclareType(r);

  l = convertType(l);
  r = convertType(r);

 // if (l == "NSString") l = "String";

  if (o.isEmpty()){ // assignment
    if (l == r) return true;
    if (l == "id" || r == "id") return true; // runtime check

    if (StringInit(l, r)){ // which can be initated with string -> runtime check
      return true;
    } else if (l == "Boolean"){
      return false;

    } else if (l == "String"){
      return false;

    } else if (l == "DateTime"){
      return false;

    } else if (l == "Integer"){
      return r == "Float" || r == "Decimal" || r == "id";

    } else if (l == "Float"){
      return r == "Integer" || r == "Decimal" || r == "id";

    } else if (l == "Decimal"){
      return r == "Integer" || r == "Float" || r == "id";

    } else { // class hierarchy

      if (checkClassHierarchy(l, r)){
        return true;
      }      

    }

  } else {
    if (l == "id" || r == "id") return true; // runtime check

    if (o == ("MUL") || o == ("POWER")){
      return (l == "Integer" || l == "Float" || l == "Decimal") && (r == "Integer" || r == "Float" || r == "Decimal");
    } else if (o == ("DIV")){
      return (l == "Integer" || l == "Float" || l == "Decimal") && (r == "Integer" || r == "Float" || r == "Decimal");
    } else if (o == ("IDIV")){
      return (l == "Integer" || l == "Float" || l == "Decimal") && (r == "Integer" || r == "Float" || r == "Decimal");
    } else if (o == ("MOD")){
      return (l == "Integer" || l == "Float" || l == "Decimal") && (r == "Integer" || r == "Float" || r == "Decimal");

    } else if (o == ("ADD")){
      if (l == "String") return true;
      if ((l == "Integer" || l == "Float" || l == "Decimal") && (r == "Integer" || r == "Float" || r == "Decimal")) return true;

#ifdef QTBASIC // OBJB
#else // OBJB
      if ((l == "NSArray" || l == "NSMutableArray" || l == "Array") && (r == "NSArray" || r == "NSMutableArray" || r == "Array")) return true;
#endif // OBJB
      return false;

    } else if (o == ("CONCAT")){

      return l == "String" || r == "String";
    } else if (o == ("SUB")){
      return (l == "Integer" || l == "Float" || l == "Decimal") && (r == "Integer" || r == "Float" || r == "Decimal");

    } else if (o == ("SHR")){
      return l == "Integer" && r == "Integer";
    } else if (o == ("SHL")){
      return l == "Integer" && r == "Integer";

    } else if (o == ("EQUALEQUAL")){
      return true; // runtime check
    } else if (o == ("EQUALEQUALEQUAL")){
      return true; // runtime check
    } else if (o == ("EQUAL")){
      if (l == "String") return true;
      if ((l == "Integer" || l == "Float" || l == "Decimal" || l == "Boolean") && (r == "Integer" || r == "Float" || r == "Decimal" || r == "Boolean")) return true;
      if (l == r) return true;

      if (checkClassHierarchy(l, r)){
        return true;
      }      

    } else if (o == ("UNEQUAL")){
      if (l == "String") return true;
      if ((l == "Integer" || l == "Float" || l == "Decimal" || l == "Boolean") && (r == "Integer" || r == "Float" || r == "Decimal" || r == "Boolean")) return true;
      if (l == r) return true;

      if (checkClassHierarchy(l, r)){
        return true;
      }     

    } else if (o == ("GREATER")){
      return (l == "Integer" || l == "Float" || l == "Decimal" || l == "Boolean") && (r == "Integer" || r == "Float" || r == "Decimal" || r == "Boolean");
    } else if (o == ("SMALLER")){
      return (l == "Integer" || l == "Float" || l == "Decimal" || l == "Boolean") && (r == "Integer" || r == "Float" || r == "Decimal" || r == "Boolean");
    } else if (o == ("GREATEREQUAL")){
      return (l == "Integer" || l == "Float" || l == "Decimal" || l == "Boolean") && (r == "Integer" || r == "Float" || r == "Decimal" || r == "Boolean");
    } else if (o == ("SMALLEREQUAL")){
      return (l == "Integer" || l == "Float" || l == "Decimal" || l == "Boolean") && (r == "Integer" || r == "Float" || r == "Decimal" || r == "Boolean");

    } else if (o == ("AND")){
      return (l == "Integer" || l == "Float" || l == "Decimal" || l == "Boolean") && (r == "Integer" || r == "Float" || r == "Decimal" || r == "Boolean");
    } else if (o == ("OR")){
      return (l == "Integer" || l == "Float" || l == "Decimal" || l == "Boolean") && (r == "Integer" || r == "Float" || r == "Decimal" || r == "Boolean");
    } else if (o == ("XOR")){
      return (l == "Integer" || l == "Float" || l == "Decimal" || l == "Boolean") && (r == "Integer" || r == "Float" || r == "Decimal" || r == "Boolean");
    } else if (o == ("ANDALSO")){
      return (l == "Integer" || l == "Float" || l == "Decimal" || l == "Boolean") && (r == "Integer" || r == "Float" || r == "Decimal" || r == "Boolean");
    } else if (o == ("ORELSE")){
      return (l == "Integer" || l == "Float" || l == "Decimal" || l == "Boolean") && (r == "Integer" || r == "Float" || r == "Decimal" || r == "Boolean");

    // unary operators
    } else if (o == ("NOT")){
      return l == "Integer" || l == "Float" || l == "Decimal" || l == "Boolean" || l == "String"; // String for  If Not sStringVar Then
    } else if (o == ("FLIP")){
      return l == "Integer";
    } else if (o == ("+")){
      return l == "Integer" || l == "Float" || l == "Decimal";
    } else if (o == ("-")){
      return l == "Integer" || l == "Float" || l == "Decimal";      

    }
    
  }
  return false;
}

void Parser::addEnumType(QString sFileName, QString sName, QString sPublicPrivateGlobal, QStringList EnumNames, QList<_statements> & EnumValues)
{
  if (Me.nPass == 0){
    _enumeration Enum;

    Enum.sPublicPrivateGlobal = sPublicPrivateGlobal;
    Enum.sFileName = sFileName;
    Enum.sName = sName;

    Enum.EnumNames = EnumNames;
    Enum.EnumValues = EnumValues;

    if (sPublicPrivateGlobal == "Global"){
      Me.GlobalEnums[sName] = Enum;
    } else {
      Me.Enums[getClassName(sFileName)][sName] = Enum;
    }  
  }
}

void Parser::addTypeType(QString sFileName, QString sName, QString sPublicPrivateGlobal, QStringList names, QStringList types, QList<_array>arrays, QList<int> sizes, QStringList encodings)
{
  if (Me.nPass == 0){
    _type Type;

    Type.sPublicPrivateGlobal = sPublicPrivateGlobal;
    Type.sFileName = sFileName;
    Type.sName = sName;

    Type.Names = names;
    Type.Types = types;
    Type.Arrays = arrays;
    Type.Sizes = sizes;
    Type.Encodings = encodings;

    if (sPublicPrivateGlobal == "Global"){
      Me.GlobalTypes[sName] = Type;
    } else {
      Me.Types[getClassName(sFileName)][sName] = Type;
    }

  }
}

void Parser::addSubFunction(QString sSubFunctionIBActionActionSignalEventDelegateSlot, QString sFileName, QString sName, _statements Statements, QString sPublicPrivateGlobal, QList<_argument> Arguments, QString sType, _array & Array)
{

  bool bExists = false;

  QString sKey;
  if (sSubFunctionIBActionActionSignalEventDelegateSlot != "Delegate"){ // delegates are not directly called, and several ones might have the same name with different arguments
    sKey = sName;
  } else {
      sKey = sName + QString().fill(':', Arguments.count());
  }

  if (sName == "tableView"){
      sName=sName;
       }
  if (Me.nPass == 0 && sSubFunctionIBActionActionSignalEventDelegateSlot != "Delegate"){ // delegates are not directly called, and several ones might have the same name with different arguments
    if (sPublicPrivateGlobal == "Global"){
      bExists = Me.GlobalSubsFunctions.contains(sKey);
    } else {
      bExists = Me.SubsFunctions[getClassName(sFileName)].contains(sKey);
    }

    if (bExists){
      //Me.nLine--; // WORKAROUND
      error("sub or function already declared with the same name in the same class '" + sName + "'"); return;
    }
  }
  
  //sType = transformType(sType);

  if (isCppObjcKeyword(sName, "Name of procedure")) return;

  _subfunction SubFunction;
  
  SubFunction.sFileName = sFileName;
  SubFunction.sPublicPrivateGlobal = sPublicPrivateGlobal;
  SubFunction.sSubFunctionIBActionActionSignalEventDelegateSlot = sSubFunctionIBActionActionSignalEventDelegateSlot;
  SubFunction.sName = sName;
  SubFunction.Arguments = Arguments;

  SubFunction.sType = sType;

  SubFunction.Statements = Statements;

  SubFunction.bCallAble = 
      ! (sSubFunctionIBActionActionSignalEventDelegateSlot == "Event"
      || sSubFunctionIBActionActionSignalEventDelegateSlot == "Action"
      || sSubFunctionIBActionActionSignalEventDelegateSlot == "Delegate"
      || sSubFunctionIBActionActionSignalEventDelegateSlot == "Signal"
   );

  SubFunction.Array = Array;

  if (sPublicPrivateGlobal == "Global"){
    Me.GlobalSubsFunctions[sKey] = SubFunction;
  } else {
    Me.SubsFunctions[getClassName(sFileName)][sKey] = SubFunction;
  }

}

void Parser::addLocalVariable(QString sName, QString sType, bool bConstant, _statements Statement, _array Array, bool bStatic)
{
  {
    for (int i = 0; i < Me.SubFunction.Arguments.size(); i++){

      _argument Argument = Me.SubFunction.Arguments.at(i);

      if (Argument.sName == sName){
        //Me.nCurrentLine--; // WORKAROUND
        error("An argument is already declared with the same name in the same sub/function and scope '" + sName + "'"); return;
      }

    }

    for (int i = 0; i < Me.SubFunction.VariablesConstants.size(); i++){

      _variableconstant vc = Me.SubFunction.VariablesConstants.at(i);

       if (vc.sName == sName && vc.nBlock >= Me.nBlock){
         // nCurrentLine--; // WORKAROUND
         error("local variable or local constant '" + sName + "' already declared with the same name in the same sub/function and scope"); return;
       }     
       //cout << i.key() << ": " << i.value() << endl;
    }
   
    // sType = transformType(sType);
  	
    _variableconstant vc;

    vc.sFileName = Me.sFileName;
    vc.nLine = Me.nLine;
    vc.sPublicPrivateGlobalLocal = "Local";
    vc.sName = sName;
    vc.sType = sType;
    vc.bConstant = bConstant;
    vc.nBlock = Me.nBlock;
    vc.Array = Array;

    Me.SubFunction.VariablesConstants << vc;

  }
}

void Parser::addVariable(QString sName, QString sType, QString sPrivatePublicGlobal, bool bConstant, bool bOutlet, _array & Array, bool bSet)
{
  if (getClassName(Me.sFileName) == "MainWindow" && Me.nLine > 1000){
    sName = sName;
  }
  if (sName == "bBlockLastPosition"){
    sName = sName;
  }
  
  if (sPrivatePublicGlobal == "Global"){
    if (Me.nPass == 0 && Me.GlobalVariablesConstants.contains(sName)){
       error("variable or constant '" + sName + "' already declared with the same name with keyword Global in global space (sub or function declared with keyword 'Global')"); return;
    }
  } else {
    if (Me.nPass == 0 && Me.VariablesConstants[getClassName(Me.sFileName)].contains(sName)){
      error("variable or constant '" + sName + "' already declared with the same name in the same class"); return;
    }
  }

  _variableconstant vc;

  vc.sFileName = Me.sFileName;
  vc.nLine = Me.nLine;
  vc.sPublicPrivateGlobalLocal = sPrivatePublicGlobal;
  vc.sName = sName;
  vc.sType = sType;
  vc.bConstant = bConstant;
  vc.nBlock = 0;
  vc.Array = Array;
  vc.bOutlet = bOutlet;

  if (sPrivatePublicGlobal == "Global"){
    Me.GlobalVariablesConstants[vc.sName] = vc;
  } else {
    Me.VariablesConstants[getClassName(Me.sFileName)][vc.sName] = vc;
  }

  if (Me.nPass == 1){
  #ifdef Q7BASIC
      Me.sOutletsName[Me.sFileName] << sName;
      Me.sOutletsType[Me.sFileName] << sType;
      Me.sOutletsSet[Me.sFileName] << ( bSet ? "true" : "");    
  #elif defined OBJB
  #elif defined DROIDBASIC
  #endif // Q7BASIC_OBJB
  }

}
