﻿/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use Expression source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/


#include "Q7BCompiler.h"


#define COMMENT ;Me.operators<<sOperator;Me.comments_operators[sOperator]._COMMENT

#define Operator ;sOperator=


void Parser::CreateListOfOperators()
{      
  QString sOperator;
    
  if (Me.operators.size() == 0){    
    
    // ----------------------------------------------------------------------------------------------------------------------------
    
    Operator "'"      COMMENT = "";
    Operator "("      COMMENT = "";
    Operator ")"      COMMENT = "";
    Operator "."      COMMENT = "";
    Operator "!"      COMMENT = "";
    Operator "==="      COMMENT = "";
    Operator "=="      COMMENT = "";
    Operator "="      COMMENT = "";
    Operator "="      COMMENT = "";
    Operator "Not"      COMMENT = "";
    Operator "<>"      COMMENT = "";
    Operator ">="      COMMENT = "";
    Operator "<="      COMMENT = "";
    Operator "Mod"      COMMENT = "";
    Operator "AndAlso"      COMMENT = "";
    Operator "OrElse"      COMMENT = "";
    Operator "And"      COMMENT = "And operator";
    Operator "Or"      COMMENT = "";
    Operator "Xor"      COMMENT = "";
    Operator "Flip"      COMMENT = "";
    Operator "Shl"      COMMENT = "";
    Operator "Shr"      COMMENT = "";
    Operator "&"      COMMENT = "";
    Operator "*"      COMMENT = "";
    Operator "/"      COMMENT = "";
    Operator "^"      COMMENT = "";
    Operator "\\"      COMMENT = "";
    Operator ":"      COMMENT = "";
    Operator "$"      COMMENT = "";
    Operator "+"      COMMENT = "";
    Operator "-"      COMMENT = "";


/*

  //addKeyword("Inc");
  //addKeyword("Dec");

  //addKeyword("{"); // <C>
  //addKeyword("}"); // </C>

  //addKeyword("?");
    addKeyword("**");

*/



    // ----------------------------------------------------------------------------------------------------------------------------
  }

  Me.operators.sort();

}

bool Parser::parseMulDivMod(_expressions & ReturnExpression)
{  
  _expressions Expression;
  if (parseFactor(Expression)){
    
    _statements Statements = Expression.Statements;

    do {
      QString sOperator;

      if (parseTerm("*")) sOperator = "MUL";
      else if (parseTerm("/")) sOperator = "DIV";
      else if (parseTerm("\\")) sOperator = "IDIV";
      else if (parseTerm("Mod")) sOperator = "MOD";
      else break;

      _expressions Expression2;

      if (!parseFactor(Expression2)){ error(""); return false; }

      if (!typeCompatible(Expression.sType, Expression2.sType, sOperator)){ error("expression types incompatible or operator not allowed with the expression types"); return false; }

      Statements = Compiler::pushOperator(sOperator, Statements, Expression2.Statements);

    } while(Me.bError == false);

    ReturnExpression.Statements << Statements;
    ReturnExpression.sType = Expression.sType;

    return true;
  }
  return false;
}

bool Parser::parseAddSub(_expressions & ReturnExpression)
{  
  _expressions Expression;
  if (parseMulDivMod(Expression)){
    _statements Statements = Expression.Statements;
    QString sReturnType0 = Expression.sType;
    do {
      QString sOperator;

      if (parseTerm("+")) sOperator = "ADD";
      else if (parseTerm("&")){
        sOperator = "CONCAT";
      }
      else if (parseTerm("-")) sOperator = "SUB";
//      else { Expression.sType = sReturnType0; return true; }
      else break;

      _expressions Expression2;

      if (!parseMulDivMod(Expression2)){ error(""); return false; }

      if (!typeCompatible(sReturnType0, Expression2.sType, sOperator)){ error("expression types incompatible or operator not allowed with the expression types"); return false; }

      Statements = Compiler::pushOperator(sOperator, Statements, Expression2.Statements);
      /*
      QString sjhdf1 = Compiler::decode(Expression.Statements);
      QString sjhdf2 = Compiler::decode(Expression2.Statements);
      QString sjhdf3 = Compiler::decode(Statements);*/

      //QString sdfs = Compiler::decode(Statements);

      if (sOperator == ("CONCAT")){
        sReturnType0 = "String";
      }
    } while(Me.bError == false);

    ReturnExpression.Statements << Statements;
    ReturnExpression.sType = sReturnType0;

    //QString sdfjgjhs = Compiler::decode(Statements);

    return true;
  }
  return false;
}

bool Parser::parseExponent(_expressions & ReturnExpression)
{  
  _expressions Expression;
  if (parseAddSub(Expression)){
    _statements Statements = Expression.Statements;
    do {
      QString sOperator;
    
      if (parseTerm("^")) sOperator = "POWER";
      else break; 

      _expressions Expression2;

      if (!parseAddSub(Expression2)){ error(""); return false; }

      if (!typeCompatible(Expression.sType, Expression2.sType, sOperator)){ error("expression types incompatible or operator not allowed with the expression types"); return false; }

      Statements = Compiler::pushOperator(sOperator, Statements, Expression2.Statements);

    } while(Me.bError == false);

    ReturnExpression.Statements << Statements;
    ReturnExpression.sType = Expression.sType;
    return true;
  }
  return false;
}

bool Parser::parseShift(_expressions & ReturnExpression)
{  
  _expressions Expression;
  if (parseExponent(Expression)){
    _statements Statements = Expression.Statements;
    do {
      QString sOperator;
    
      if (parseTerm("Shl")) sOperator = "SHR";
      else if (parseTerm("Shr")) sOperator = "SHL";
      else break; 

      _expressions Expression2;

      if (!parseExponent(Expression2)){ error(""); return false; }

      if (!typeCompatible(Expression.sType, Expression2.sType, sOperator)){ error("expression types incompatible or operator not allowed with the expression types"); return false; }

      Statements = Compiler::pushOperator(sOperator, Statements, Expression2.Statements);

    } while(Me.bError == false);

    ReturnExpression.Statements << Statements;
    ReturnExpression.sType = Expression.sType;
    return true;
  }
  return false;
}

bool Parser::parseComparision(_expressions & ReturnExpression)
{  
  _expressions Expression;
  if (parseShift(Expression)){
    _statements Statements = Expression.Statements;
    do {
      QString sOperator;            

      if (parseTerm("=")){ sOperator = "EQUAL"; }
      else if (parseTerm("==")){
        sOperator = "EQUALEQUAL"; 
      } else if (parseTerm("===")){ 
        sOperator = "EQUALEQUALEQUAL"; } 

      else if (parseTerm("<>")){ sOperator = "UNEQUAL"; } 
      else if (parseTerm(">")){ sOperator = "GREATER"; } 
      else if (parseTerm("<")){ sOperator = "SMALLER"; } 
      else if (parseTerm(">=")){ sOperator = "GREATEREQUAL"; }
      else if (parseTerm("<=")){ sOperator = "SMALLEREQUAL"; }
      else break;
#ifdef ASDFADSFWERBERND // OBJB
      /*


      if (parseTerm("=")){ sOperator = "EQUAL"; } //*sReturnType = "Boolean"; }
      else if (parseTerm("==")){
        sOperator = "EQUALEQUAL"; //*sReturnType = "Boolean";
      } else if (parseTerm("===")){ 
        sOperator = "EQUALEQUALEQUAL"; /*bEQUALEQUALEQUAL = true;*/ } //*sReturnType = "Boolean"; }

      else if (parseTerm("<>")){ sOperator = "UNEQUAL"; } //*sReturnType = "Boolean"; }
      else if (parseTerm(">")){ sOperator = "GREATER"; } //*sReturnType = "Boolean"; }
      else if (parseTerm("<")){ sOperator = "SMALLER"; } //*sReturnType = "Boolean"; }
      else if (parseTerm(">=")){ sOperator = "GREATEREQUAL"; } //*sReturnType = "Boolean"; }
      else if (parseTerm("<=")){ sOperator = "SMALLEREQUAL"; } //*sReturnType = "Boolean"; }
      else return true;

      */
    #endif // OBJB
      _expressions Expression2;

      if (!parseShift(Expression2)){ 
        /*
        #ifdef QTBASIC // OBJB
        #else // OBJB
          if (bEQUALEQUALEQUAL){
            QString sType;
            QString sTypeL;              
            QString sTypeR;
            if (!parseType(&sType, &sTypeL, &sTypeR)){ error(""); return false; }

//               Expression.Statements = "CBOOLEAN(NSOBJECT([" + Expression.Statements + " isKindOfClass:[" + sType + " class]]))";    

            if (!typeCompatible(Expression.sType, Expression2.sType, sOperator)){ error("expression types incompatible or operator not allowed with the expression types"); return false; }

            if (Me.bError == false) continue;
            return true;
          }
        #endif // OBJB*/

        error(""); return false; 
      }
    
      if (!typeCompatible(Expression.sType, Expression2.sType, sOperator)){ error("expression types incompatible or operator not allowed with the expression types"); return false; }

      Statements = Compiler::pushOperator(sOperator, Statements, Expression2.Statements);
      Expression.sType = "Boolean";

    } while(Me.bError == false);

    ReturnExpression.Statements << Statements;
    ReturnExpression.sType = Expression.sType;
    return true;
  }
  return false;
}

bool Parser::parseAnd(_expressions & ReturnExpression)
{  
  _expressions Expression;
  if (parseComparision(Expression)){
    _statements Statements = Expression.Statements;
    do {

      if (parseTerm("And")){

        _expressions Expression2;

        if (!parseComparision(Expression2)){ error(""); return false; }

        if (!typeCompatible(Expression.sType, Expression2.sType, "AND")){ error("expression types incompatible or operator not allowed with the expression types"); return false; }

        Statements = Compiler::pushOperator("AND", Statements, Expression2.Statements);

      }  
      else break;

    } while(Me.bError == false);

    ReturnExpression.Statements << Statements;
    ReturnExpression.sType = Expression.sType;
    return true;
  }
  return false;
}

bool Parser::parseOr(_expressions & ReturnExpression)
{  
  _expressions Expression;
  if (parseAnd(Expression)){
    _statements Statements = Expression.Statements;
    do {

      if (parseTerm("Or")){
        
        _expressions Expression2;

        if (!parseAnd(Expression2)){ error(""); return false; }

        if (!typeCompatible(Expression.sType, Expression2.sType, "OR")){ error("expression types incompatible or operator not allowed with the expression types"); return false; }

        Statements = Compiler::pushOperator("OR", Statements, Expression2.Statements);

      } else if (parseTerm("Xor")){
        
        _expressions Expression2;

        if (!parseAnd(Expression2)){ error(""); return false; }

        if (!typeCompatible(Expression.sType, Expression2.sType, "XOR")){ error("expression types incompatible or operator not allowed with the expression types"); return false; }

        Statements = Compiler::pushOperator("XOR", Statements, Expression2.Statements);

      } else break;

    } while(Me.bError == false);

    ReturnExpression.Statements << Statements;
    ReturnExpression.sType = Expression.sType;
    return true;
  }
  return false;
}

bool Parser::parseAndAlso(_expressions & ReturnExpression)
{  
  _expressions Expression;
  if (parseOr(Expression)){
    _statements Statements = Expression.Statements;
    do {

      if (parseTerm("AndAlso")){

        _expressions Expression2;

        if (!parseOr(Expression2)){ error(""); return false; }

        Statements = Compiler::pushOperator("ANDALSO", Statements, Expression2.Statements);

      } else break;

    } while(Me.bError == false);

    ReturnExpression.Statements << Statements;
    ReturnExpression.sType = Expression.sType;
    return true;
  }
  return false;
}

bool Parser::parseOrElse(_expressions & ReturnExpression)
{  
  _expressions Expression;
  if (parseAndAlso(Expression)){
    _statements Statements = Expression.Statements;
    do {

      if (parseTerm("OrElse")){
        
        _expressions Expression2;

        if (!parseAndAlso(Expression2)){ error(""); return false; }

        Statements = Compiler::pushOperator("ORELSE", Statements, Expression2.Statements);

      } else break;

    } while(Me.bError == false);

    ReturnExpression.Statements << Statements;
    ReturnExpression.sType = Expression.sType;
    return true;
  }
  return false;
}


#undef COMMENT
#undef Operator
