#include "qresizeblesplitter.h"

QResizebleSplitter::QResizebleSplitter ( QWidget *parent) :
    QSplitter ( Qt::Vertical, parent )
{
}

void QResizebleSplitter::enlargeSectionHeight ( int d )
{
    QWidget * w = qobject_cast< QWidget * > ( sender () ) ;
    if ( ! w )
        return ;
    int i = indexOf ( w ) ;
    if ( i < count () - 1  )
    {
        int newPos = 0 ;
        for ( int j = 0 ; j <= i ; j ++ )
            newPos += handle ( j + 1 )->height ()  + widget ( j )->height () ;
        moveSplitter ( newPos + d - w->height () , i + 1 ) ;
    }
    else
        emit enlargeHeight ( height () + d - widget ( count () - 1 )->height () ) ;
}

QVariantMap QResizebleSplitter::positions ( )
{
    QVariantMap ret ;
    for ( int i = 1 ; i < count() ; i ++ )
        ret.insert ( QString::number ( i ) , handle ( i )->y() ) ;
    return ret ;
}

void QResizebleSplitter::setPositions ( QVariantMap p )
{
    for ( int i = 1 ; i <=  p.count() && i < count () ; i ++ )
        moveSplitter ( p.value ( QString::number ( i ) ).toInt() , i ) ;
}
