
/*
'***************************************************************************
'Copyright (C) 2010-2012 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher (or company employees) sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/

#include "QuaZipWrapper.h"



bool Zip( QString Path )
{
    QFileInfo PathInfo( Path ) ;
    if( ! PathInfo.exists() )
        return false ;
    //creation of suiting name
    QString ZipName = PathInfo.absoluteFilePath() + ARCH_SUFFIX ;
    int c = 1 ;
    while( QFileInfo( ZipName ).exists() )
    {
        ZipName = PathInfo.absoluteFilePath() + QString::number( c ) + ARCH_SUFFIX ;
        c ++ ; //of course it is not too smart in a case of great number of same-named files.
    }

    if( PathInfo.isFile() )
    {
        return JlCompress::compressFile( ZipName , PathInfo.absoluteFilePath() ) ;
    }
    else if( PathInfo.isDir() )
    {
        return JlCompress::compressDir( ZipName , PathInfo.absoluteFilePath() ) ;
    }

    return false ;
}

bool UnZip( QString Path )
{
    QFileInfo PathInfo( Path ) ;
    if( ! PathInfo.exists() )
        return false ;

    QStringList FileList = JlCompress::getFileList( Path ) ;

    if( FileList.count() == 1 )
    {
        //creation of suiting name
        QString NameOfExtracted = PathInfo.absolutePath() + "/" +
                                        QFileInfo( FileList[ 0 ] ).path() + "/" +
                                        QFileInfo( FileList[ 0 ] ).baseName() ;
        if( QFileInfo( FileList[ 0 ] ).completeSuffix() != "" )
            NameOfExtracted += "." + QFileInfo( FileList[ 0 ] ).completeSuffix() ;
        int c = 1 ;
        while( QFileInfo( NameOfExtracted ).exists() )
        {
            NameOfExtracted =  PathInfo.absolutePath() + "/" +
                                        QFileInfo( FileList[ 0 ] ).path() + "/" +
                                        QFileInfo( FileList[ 0 ] ).baseName() +
                                        QString::number( c ) ;
            if( QFileInfo( FileList[ 0 ] ).completeSuffix() != "" )
                NameOfExtracted += "." + QFileInfo( FileList[ 0 ] ).completeSuffix() ;
            c ++ ;
        }

        QString r = JlCompress::extractFile( Path , FileList[ 0 ] , NameOfExtracted ) ;
        return r != "" ;
    }
    else
    {
        //creation of suiting name
        QString NameOfExtracted = PathInfo.absolutePath() + "/" + PathInfo.baseName() ;
        int c = 1 ;
        while( QFileInfo( NameOfExtracted ).exists() )
        {
            NameOfExtracted = PathInfo.absolutePath() + "/" +
                                        PathInfo.baseName() +
                                        QString::number( c ) ;
            c ++ ;
        }
        QStringList el = JlCompress::extractDir( Path , NameOfExtracted ) ;
        return el.count() != 0 || FileList.count() == 0 ;
    }

    return false ;
}
