#ifndef QUAZIPWRAPPER_H
#define QUAZIPWRAPPER_H

/*
'***************************************************************************
'Copyright (C) 2010-2012 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher (or company employees) sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/

#include <QtCore>
#include <QFileInfo>

#include "quazip/JlCompress.h"

#define ARCH_SUFFIX ".zip"

/*
  Compresses file or folder "name" to archive "name.zip" which
  located in the same folder.
  If "name.zip" already exists, archive "name1.zip"
  ("name2.zip" and so on) will be created.
  Returns "true" on success and "false" on failure.
*/
bool Zip( QString Path ) ;

/*
  Extracts archive "name".
  If it contains only one file with name "name.ext",
  file "name.ext" will be created.
  If "name.ext" already exists, file "name1.ext" ("name2.ext" and so on)
  will be created.
  If it contains more than one file or folder,
  all items will be extracted to folder "name" (or "name1", "name2"...)
  If the archive is empty(i.e. does not contains any files),
  functions does nothing and returns "true".
  Returns "true" on success and "false" on failure.
*/
bool UnZip( QString Path ) ;

#endif // QUAZIPWRAPPER_H
